/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAnimationFrameRatePreset.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(AnimationFrameRatePreset enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("auto"),
        MAKE_STATIC_STRING_IMPL("low"),
        MAKE_STATIC_STRING_IMPL("high"),
        MAKE_STATIC_STRING_IMPL("highest"),
    };
    static_assert(static_cast<size_t>(AnimationFrameRatePreset::Auto) == 0, "AnimationFrameRatePreset::Auto is not 0 as expected");
    static_assert(static_cast<size_t>(AnimationFrameRatePreset::Low) == 1, "AnimationFrameRatePreset::Low is not 1 as expected");
    static_assert(static_cast<size_t>(AnimationFrameRatePreset::High) == 2, "AnimationFrameRatePreset::High is not 2 as expected");
    static_assert(static_cast<size_t>(AnimationFrameRatePreset::Highest) == 3, "AnimationFrameRatePreset::Highest is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, AnimationFrameRatePreset enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<AnimationFrameRatePreset> parseEnumeration<AnimationFrameRatePreset>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    static constexpr std::pair<ComparableASCIILiteral, AnimationFrameRatePreset> mappings[] = {
        { "auto", AnimationFrameRatePreset::Auto },
        { "high", AnimationFrameRatePreset::High },
        { "highest", AnimationFrameRatePreset::Highest },
        { "low", AnimationFrameRatePreset::Low },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<AnimationFrameRatePreset>()
{
    return "\"auto\", \"low\", \"high\", \"highest\"";
}

} // namespace WebCore
