/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCustomElementRegistry.h"

#include "ActiveDOMObject.h"
#include "CustomElementReactionQueue.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "IDLTypes.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertBase.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSNode.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include "WebCoreOpaqueRoot.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_define);
static JSC_DECLARE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_get);
static JSC_DECLARE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_whenDefined);
static JSC_DECLARE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_upgrade);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsCustomElementRegistryConstructor);

class JSCustomElementRegistryPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCustomElementRegistryPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCustomElementRegistryPrototype* ptr = new (NotNull, JSC::allocateCell<JSCustomElementRegistryPrototype>(vm)) JSCustomElementRegistryPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCustomElementRegistryPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCustomElementRegistryPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCustomElementRegistryPrototype, JSCustomElementRegistryPrototype::Base);

using JSCustomElementRegistryDOMConstructor = JSDOMConstructorNotConstructable<JSCustomElementRegistry>;

template<> const ClassInfo JSCustomElementRegistryDOMConstructor::s_info = { "CustomElementRegistry"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistryDOMConstructor) };

template<> JSValue JSCustomElementRegistryDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCustomElementRegistryDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "CustomElementRegistry"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSCustomElementRegistry::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSCustomElementRegistryPrototypeTableValues[] =
{
    { "constructor"_s, static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCustomElementRegistryConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "define"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunction_define), (intptr_t) (2) } },
    { "get"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunction_get), (intptr_t) (1) } },
    { "whenDefined"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunction_whenDefined), (intptr_t) (1) } },
    { "upgrade"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunction_upgrade), (intptr_t) (1) } },
};

const ClassInfo JSCustomElementRegistryPrototype::s_info = { "CustomElementRegistry"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistryPrototype) };

void JSCustomElementRegistryPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCustomElementRegistry::info(), JSCustomElementRegistryPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSCustomElementRegistry::s_info = { "CustomElementRegistry"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistry) };

JSCustomElementRegistry::JSCustomElementRegistry(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CustomElementRegistry>&& impl)
    : JSDOMWrapper<CustomElementRegistry>(structure, globalObject, WTFMove(impl))
{
}

void JSCustomElementRegistry::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));

    static_assert(!std::is_base_of<ActiveDOMObject, CustomElementRegistry>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSCustomElementRegistry::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCustomElementRegistryPrototype::create(vm, &globalObject, JSCustomElementRegistryPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCustomElementRegistry::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCustomElementRegistry>(vm, globalObject);
}

JSValue JSCustomElementRegistry::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCustomElementRegistryDOMConstructor, DOMConstructorID::CustomElementRegistry>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCustomElementRegistry::destroy(JSC::JSCell* cell)
{
    JSCustomElementRegistry* thisObject = static_cast<JSCustomElementRegistry*>(cell);
    thisObject->JSCustomElementRegistry::~JSCustomElementRegistry();
}

JSC_DEFINE_CUSTOM_GETTER(jsCustomElementRegistryConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSCustomElementRegistryPrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSCustomElementRegistry::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunction_defineBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    RELEASE_AND_RETURN(throwScope, (JSValue::encode(castedThis->define(*lexicalGlobalObject, *callFrame))));
}

JSC_DEFINE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_define, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunction_defineBody>(*lexicalGlobalObject, *callFrame, "define");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunction_getBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto name = convert<IDLAtomStringAdaptor<IDLDOMString>>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLAny>(*lexicalGlobalObject, throwScope, impl.get(WTFMove(name)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_get, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunction_getBody>(*lexicalGlobalObject, *callFrame, "get");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunction_whenDefinedBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSCustomElementRegistry>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    RELEASE_AND_RETURN(throwScope, (JSValue::encode(castedThis->whenDefined(*lexicalGlobalObject, *callFrame))));
}

JSC_DEFINE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_whenDefined, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperationReturningPromise<JSCustomElementRegistry>::callReturningOwnPromise<jsCustomElementRegistryPrototypeFunction_whenDefinedBody>(*lexicalGlobalObject, *callFrame, "whenDefined");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunction_upgradeBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto root = convert<IDLInterface<Node>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "root", "CustomElementRegistry", "upgrade", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUndefined>(*lexicalGlobalObject, throwScope, [&]() -> decltype(auto) { return impl.upgrade(*root); })));
}

JSC_DEFINE_HOST_FUNCTION(jsCustomElementRegistryPrototypeFunction_upgrade, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunction_upgradeBody>(*lexicalGlobalObject, *callFrame, "upgrade");
}

JSC::GCClient::IsoSubspace* JSCustomElementRegistry::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSCustomElementRegistry, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForCustomElementRegistry.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForCustomElementRegistry = WTFMove(space); },
        [] (auto& spaces) { return spaces.m_subspaceForCustomElementRegistry.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForCustomElementRegistry = WTFMove(space); }
    );
}

void JSCustomElementRegistry::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSCustomElementRegistry*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSCustomElementRegistryOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsCustomElementRegistry = jsCast<JSCustomElementRegistry*>(handle.slot()->asCell());
    ScriptExecutionContext* owner = WTF::getPtr(jsCustomElementRegistry->wrapped().scriptExecutionContext());
    if (!owner)
        return false;
    if (UNLIKELY(reason))
        *reason = "Reachable from ScriptExecutionContext";
    return containsWebCoreOpaqueRoot(visitor, owner);
}

void JSCustomElementRegistryOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCustomElementRegistry = static_cast<JSCustomElementRegistry*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCustomElementRegistry->wrapped(), jsCustomElementRegistry);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7CustomElementRegistry@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21CustomElementRegistryE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<CustomElementRegistry>&& impl)
{

    if constexpr (std::is_polymorphic_v<CustomElementRegistry>) {
#if ENABLE(BINDING_INTEGRITY)
        const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7CustomElementRegistry@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore21CustomElementRegistryE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // CustomElementRegistry has subclasses. If CustomElementRegistry has subclasses that get passed
        // to toJS() we currently require CustomElementRegistry you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    }
    return createWrapper<CustomElementRegistry>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, CustomElementRegistry& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

CustomElementRegistry* JSCustomElementRegistry::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSCustomElementRegistry*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}
