/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUBlendOperation.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(GPUBlendOperation enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("add"),
        MAKE_STATIC_STRING_IMPL("subtract"),
        MAKE_STATIC_STRING_IMPL("reverse-subtract"),
        MAKE_STATIC_STRING_IMPL("min"),
        MAKE_STATIC_STRING_IMPL("max"),
    };
    static_assert(static_cast<size_t>(GPUBlendOperation::Add) == 0, "GPUBlendOperation::Add is not 0 as expected");
    static_assert(static_cast<size_t>(GPUBlendOperation::Subtract) == 1, "GPUBlendOperation::Subtract is not 1 as expected");
    static_assert(static_cast<size_t>(GPUBlendOperation::ReverseSubtract) == 2, "GPUBlendOperation::ReverseSubtract is not 2 as expected");
    static_assert(static_cast<size_t>(GPUBlendOperation::Min) == 3, "GPUBlendOperation::Min is not 3 as expected");
    static_assert(static_cast<size_t>(GPUBlendOperation::Max) == 4, "GPUBlendOperation::Max is not 4 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, GPUBlendOperation enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<GPUBlendOperation> parseEnumeration<GPUBlendOperation>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    static constexpr std::pair<ComparableASCIILiteral, GPUBlendOperation> mappings[] = {
        { "add", GPUBlendOperation::Add },
        { "max", GPUBlendOperation::Max },
        { "min", GPUBlendOperation::Min },
        { "reverse-subtract", GPUBlendOperation::ReverseSubtract },
        { "subtract", GPUBlendOperation::Subtract },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<GPUBlendOperation>()
{
    return "\"add\", \"subtract\", \"reverse-subtract\", \"min\", \"max\"";
}

} // namespace WebCore
