/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO)

#include "JSVideoColorSpaceInit.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMGlobalObject.h"
#include "JSVideoColorPrimaries.h"
#include "JSVideoMatrixCoefficients.h"
#include "JSVideoTransferCharacteristics.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(VIDEO)

template<> VideoColorSpaceInit convertDictionary<VideoColorSpaceInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    VideoColorSpaceInit result;
    JSValue fullRangeValue;
    if (isNullOrUndefined)
        fullRangeValue = jsUndefined();
    else {
        fullRangeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "fullRange"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!fullRangeValue.isUndefined()) {
        result.fullRange = convert<IDLBoolean>(lexicalGlobalObject, fullRangeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue matrixValue;
    if (isNullOrUndefined)
        matrixValue = jsUndefined();
    else {
        matrixValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "matrix"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!matrixValue.isUndefined()) {
        result.matrix = convert<IDLEnumeration<VideoMatrixCoefficients>>(lexicalGlobalObject, matrixValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue primariesValue;
    if (isNullOrUndefined)
        primariesValue = jsUndefined();
    else {
        primariesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "primaries"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!primariesValue.isUndefined()) {
        result.primaries = convert<IDLEnumeration<VideoColorPrimaries>>(lexicalGlobalObject, primariesValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue transferValue;
    if (isNullOrUndefined)
        transferValue = jsUndefined();
    else {
        transferValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "transfer"_s));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!transferValue.isUndefined()) {
        result.transfer = convert<IDLEnumeration<VideoTransferCharacteristics>>(lexicalGlobalObject, transferValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const VideoColorSpaceInit& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    if (!IDLBoolean::isNullValue(dictionary.fullRange)) {
        auto fullRangeValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, IDLBoolean::extractValueFromNullable(dictionary.fullRange));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "fullRange"_s), fullRangeValue);
    }
    if (!IDLEnumeration<VideoMatrixCoefficients>::isNullValue(dictionary.matrix)) {
        auto matrixValue = toJS<IDLEnumeration<VideoMatrixCoefficients>>(lexicalGlobalObject, throwScope, IDLEnumeration<VideoMatrixCoefficients>::extractValueFromNullable(dictionary.matrix));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "matrix"_s), matrixValue);
    }
    if (!IDLEnumeration<VideoColorPrimaries>::isNullValue(dictionary.primaries)) {
        auto primariesValue = toJS<IDLEnumeration<VideoColorPrimaries>>(lexicalGlobalObject, throwScope, IDLEnumeration<VideoColorPrimaries>::extractValueFromNullable(dictionary.primaries));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "primaries"_s), primariesValue);
    }
    if (!IDLEnumeration<VideoTransferCharacteristics>::isNullValue(dictionary.transfer)) {
        auto transferValue = toJS<IDLEnumeration<VideoTransferCharacteristics>>(lexicalGlobalObject, throwScope, IDLEnumeration<VideoTransferCharacteristics>::extractValueFromNullable(dictionary.transfer));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "transfer"_s), transferValue);
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(VIDEO)
