/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO)

#include "JSVideoTransferCharacteristics.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(VideoTransferCharacteristics enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("bt709"),
        MAKE_STATIC_STRING_IMPL("smpte170m"),
        MAKE_STATIC_STRING_IMPL("iec61966-2-1"),
    };
    static_assert(static_cast<size_t>(VideoTransferCharacteristics::Bt709) == 0, "VideoTransferCharacteristics::Bt709 is not 0 as expected");
    static_assert(static_cast<size_t>(VideoTransferCharacteristics::Smpte170m) == 1, "VideoTransferCharacteristics::Smpte170m is not 1 as expected");
    static_assert(static_cast<size_t>(VideoTransferCharacteristics::Iec6196621) == 2, "VideoTransferCharacteristics::Iec6196621 is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, VideoTransferCharacteristics enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<VideoTransferCharacteristics> parseEnumeration<VideoTransferCharacteristics>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    static constexpr std::pair<ComparableASCIILiteral, VideoTransferCharacteristics> mappings[] = {
        { "bt709", VideoTransferCharacteristics::Bt709 },
        { "iec61966-2-1", VideoTransferCharacteristics::Iec6196621 },
        { "smpte170m", VideoTransferCharacteristics::Smpte170m },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<VideoTransferCharacteristics>()
{
    return "\"bt709\", \"smpte170m\", \"iec61966-2-1\"";
}

} // namespace WebCore

#endif // ENABLE(VIDEO)
