/*
 * Copyright (c) 2007, 2015, 2022 -2022 Apple Inc. All rights reserved.
 * Copyright (c) 2013 Google Inc. All rights reserved.
 * Copyright (c) 2014, 2015, 2016, 2019 Apple Inc. All rights reserved.
 * Copyright (c) 2014, 2017 -2017 Apple Inc. All rights reserved.
 * Copyright (c) 2015 Andy VanWagoner <andy@vanwagoner.family>.
 * Copyright (c) 2015 Jordan Harband. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Apple Inc. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2015, 2016, 2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016 Caitlin Potter <caitp@igalia.com>.
 * Copyright (c) 2016 Yusuke Suzuki <utatane.tea@gmail.com>
 * Copyright (c) 2016, 2017 -2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016, 2017, 2018 Oleksandr Skachkov <gskachkov@gmail.com>.
 * Copyright (c) 2016, 2018 -2018 Apple Inc. All rights reserved.
 * Copyright (c) 2016, 2019 -2019 Apple Inc. All rights reserved.
 * Copyright (c) 2017 Caio Lima <ticaiolima@gmail.com>.
 * Copyright (c) 2018 Yusuke Suzuki <yusukesuzuki@slowstart.org>.
 * Copyright (c) 2019 Alexey Shvayka <shvaikalesh@gmail.com>.
 * Copyright (c) 2021 Igalia S.L.
 * Copyright (c) 2022 Jarred Sumner. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "JSCBuiltins.h"

#include "BuiltinExecutables.h"
#include "HeapInlines.h"
#include "IdentifierInlines.h"
#include "ImplementationVisibility.h"
#include "Intrinsic.h"
#include "JSCellInlines.h"
#include "UnlinkedFunctionExecutable.h"
#include "VM.h"

namespace JSC {

const char s_JSCCombinedCode[] = { 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 44, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 102, 97, 108, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 44, 32, 114, 101, 103, 69, 120, 112, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 44, 32, 103, 108, 111, 98, 97, 108, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 105, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 117, 110, 105, 99, 111, 100, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 50, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 91, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 102, 117, 108, 102, 105, 108, 108, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 114, 101, 106, 101, 99, 116, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 115, 111, 110, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 91, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 93, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 110, 97, 109, 101, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 114, 114, 111, 114, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 114, 114, 111, 114, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 110, 101, 119, 32, 64, 65, 103, 103, 114, 101, 103, 97, 116, 101, 69, 114, 114, 111, 114, 40, 101, 114, 114, 111, 114, 115, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 114, 114, 111, 114, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 110, 101, 119, 32, 64, 65, 103, 103, 114, 101, 103, 97, 116, 101, 69, 114, 114, 111, 114, 40, 101, 114, 114, 111, 114, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 116, 104, 105, 114, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 105, 115, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 97, 114, 114, 97, 121, 41, 32, 63, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 41, 32, 58, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 105, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 61, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 32, 123, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 110, 32, 97, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 69, 110, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 123, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 58, 32, 110, 117, 108, 108, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 69, 120, 101, 99, 117, 116, 105, 111, 110, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 116, 97, 116, 111, 114, 39, 115, 32, 81, 117, 101, 117, 101, 32, 105, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 76, 105, 115, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 105, 116, 101, 109, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 105, 116, 101, 109, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 108, 97, 115, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 115, 104, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 105, 110, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 33, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 109, 111, 100, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 41, 59, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 32, 124, 124, 32, 64, 105, 115, 83, 117, 115, 112, 101, 110, 100, 89, 105, 101, 108, 100, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 32, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 65, 119, 97, 105, 116, 101, 100, 40, 114, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 65, 119, 97, 105, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 65, 98, 115, 116, 114, 97, 99, 116, 77, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 64, 97, 98, 115, 116, 114, 97, 99, 116, 77, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 97, 114, 114, 97, 121, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 32, 32, 32, 32, 10, 123, 32, 32, 32, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 32, 32, 32, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 32, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 32, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 32, 32, 32, 32, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 115, 116, 114, 105, 110, 103, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 116, 104, 105, 115, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 32, 125, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 105, 103, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 105, 103, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 116, 104, 105, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 110, 115, 105, 100, 101, 32, 70, 117, 110, 99, 116, 105, 111, 110, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 105, 110, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 103, 117, 109, 101, 110, 116, 115, 66, 117, 116, 116, 101, 114, 102, 108, 121, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 104, 97, 115, 79, 119, 110, 76, 101, 110, 103, 116, 104, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 97, 114, 103, 101, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 32, 116, 97, 114, 103, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 62, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 45, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 32, 61, 32, 116, 97, 114, 103, 101, 116, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 110, 97, 109, 101, 32, 33, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 32, 61, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 107, 101, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 110, 97, 109, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 108, 105, 110, 107, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 111, 108, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 109, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 98, 117, 105, 108, 116, 105, 110, 77, 97, 112, 73, 116, 101, 114, 97, 98, 108, 101, 32, 99, 97, 108, 108, 101, 100, 32, 119, 105, 116, 104, 32, 110, 111, 110, 45, 77, 97, 112, 32, 111, 98, 106, 101, 99, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 109, 97, 112, 46, 64, 101, 110, 116, 114, 105, 101, 115, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 109, 97, 112, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 115, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 98, 117, 105, 108, 116, 105, 110, 83, 101, 116, 73, 116, 101, 114, 97, 98, 108, 101, 32, 99, 97, 108, 108, 101, 100, 32, 119, 105, 116, 104, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 115, 101, 116, 46, 64, 118, 97, 108, 117, 101, 115, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 115, 101, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 44, 32, 105, 45, 49, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 115, 111, 117, 114, 99, 101, 41, 46, 64, 116, 104, 101, 110, 40, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 67, 111, 109, 112, 105, 108, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 105, 114, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 116, 104, 105, 115, 44, 32, 34, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 34, 41, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 102, 105, 114, 115, 116, 41, 32, 124, 124, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 102, 105, 114, 115, 116, 44, 32, 34, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 34, 41, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 41, 32, 123, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 111, 110, 99, 97, 116, 77, 101, 109, 99, 112, 121, 40, 116, 104, 105, 115, 44, 32, 102, 105, 114, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 99, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 115, 116, 114, 105, 110, 103, 67, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 61, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 32, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 64, 64, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 32, 124, 124, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 32, 38, 38, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 60, 61, 32, 64, 77, 65, 88, 95, 65, 82, 82, 65, 89, 95, 73, 78, 68, 69, 88, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 112, 112, 101, 110, 100, 77, 101, 109, 99, 112, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 97, 114, 103, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 97, 114, 103, 73, 110, 100, 101, 120, 43, 43, 32, 60, 32, 97, 114, 103, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 116, 97, 114, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 112, 121, 87, 105, 116, 104, 105, 110, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 116, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 111, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 101, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 117, 110, 116, 32, 61, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 45, 32, 102, 114, 111, 109, 44, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 116, 111, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 60, 32, 116, 111, 32, 38, 38, 32, 116, 111, 32, 60, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 45, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 32, 61, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 111, 32, 61, 32, 116, 111, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 43, 43, 105, 44, 32, 102, 114, 111, 109, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 44, 32, 116, 111, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 32, 61, 32, 97, 114, 114, 97, 121, 91, 102, 114, 111, 109, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 97, 114, 114, 97, 121, 32, 61, 32, 110, 101, 119, 32, 64, 65, 114, 114, 97, 121, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 97, 114, 114, 97, 121, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 97, 114, 114, 97, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 79, 110, 108, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 97, 110, 32, 98, 101, 32, 119, 114, 97, 112, 112, 101, 100, 32, 98, 121, 32, 97, 115, 121, 110, 99, 45, 102, 114, 111, 109, 45, 115, 121, 110, 99, 32, 119, 114, 97, 112, 112, 101, 114, 39, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 65, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 117, 110, 99, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 116, 97, 103, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 116, 114, 105, 110, 103, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 96, 36, 123, 102, 117, 110, 99, 125, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 96, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 83, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 49, 32, 61, 32, 34, 60, 34, 32, 43, 32, 116, 97, 103, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 86, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 61, 32, 86, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 47, 34, 47, 103, 44, 32, 39, 38, 113, 117, 111, 116, 59, 39, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 49, 32, 61, 32, 112, 49, 32, 43, 32, 34, 32, 34, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 43, 32, 39, 61, 34, 39, 32, 43, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 43, 32, 39, 34, 39, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 50, 32, 61, 32, 112, 49, 32, 43, 32, 34, 62, 34, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 51, 32, 61, 32, 112, 50, 32, 43, 32, 83, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 52, 32, 61, 32, 112, 51, 32, 43, 32, 34, 60, 47, 34, 32, 43, 32, 116, 97, 103, 32, 43, 32, 34, 62, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 52, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 41, 10, 123, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 40, 41, 32, 123, 125, 10, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 32, 61, 32, 110, 117, 108, 108, 59, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 49, 32, 47, 32, 111, 98, 106, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 45, 48, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 32, 43, 32, 34, 110, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 85, 73, 110, 116, 51, 50, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 32, 62, 62, 62, 32, 48, 32, 61, 61, 61, 32, 111, 98, 106, 32, 38, 38, 32, 40, 111, 98, 106, 32, 62, 32, 48, 32, 124, 124, 32, 49, 32, 47, 32, 111, 98, 106, 32, 62, 32, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 32, 43, 32, 40, 111, 98, 106, 32, 62, 62, 62, 32, 48, 41, 32, 61, 61, 61, 32, 111, 98, 106, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 115, 121, 109, 98, 111, 108, 34, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 69, 109, 112, 116, 121, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 10, 123, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 107, 101, 121, 32, 105, 110, 32, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 33, 33, 118, 97, 108, 117, 101, 32, 124, 124, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 98, 111, 111, 108, 101, 97, 110, 34, 58, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 110, 117, 109, 98, 101, 114, 34, 58, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 115, 116, 114, 105, 110, 103, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 33, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 125, 10, 32, 32, 32, 32, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 41, 32, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 97, 120, 40, 97, 44, 32, 98, 41, 32, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 62, 32, 98, 32, 63, 32, 97, 32, 58, 32, 98, 59, 10, 125, 10, 10, 47, 47, 10, 10, 108, 101, 116, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 61, 32, 99, 108, 97, 115, 115, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 66, 111, 117, 110, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 101, 40, 102, 117, 110, 99, 116, 105, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 97, 114, 103, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 102, 117, 110, 99, 116, 105, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 46, 64, 97, 112, 112, 108, 121, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 97, 119, 97, 105, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 32, 105, 110, 115, 116, 97, 110, 99, 101, 111, 102, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 79, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 80, 114, 111, 109, 105, 115, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 118, 97, 108, 117, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 46, 64, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 99, 97, 108, 108, 70, 114, 97, 109, 101, 70, 111, 114, 73, 100, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 99, 97, 108, 108, 32, 102, 114, 97, 109, 101, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 97, 108, 108, 70, 117, 110, 99, 116, 105, 111, 110, 79, 110, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 97, 114, 103, 115, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 65, 114, 103, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 97, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 97, 108, 108, 65, 114, 103, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 91, 105, 93, 32, 61, 32, 116, 104, 105, 115, 46, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 83, 116, 114, 105, 110, 103, 40, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 117, 110, 99, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 102, 117, 110, 99, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 71, 105, 118, 101, 110, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 111, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 102, 117, 110, 99, 46, 64, 97, 112, 112, 108, 121, 40, 111, 98, 106, 101, 99, 116, 44, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 41, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 70, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 98, 121, 32, 105, 100, 46, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 116, 97, 105, 108, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 102, 117, 110, 99, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 116, 97, 105, 108, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 100, 101, 116, 97, 105, 108, 115, 46, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 116, 97, 105, 108, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 63, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 58, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 34, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 34, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 34, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 68, 105, 115, 112, 108, 97, 121, 97, 98, 108, 101, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 124, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 34, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 34, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 34, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 124, 124, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 32, 33, 61, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 116, 104, 105, 115, 46, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 121, 32, 61, 32, 101, 110, 116, 114, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 107, 101, 121, 34, 32, 105, 110, 32, 101, 110, 116, 114, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 115, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 112, 116, 104, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 119, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 40, 100, 101, 112, 116, 104, 43, 43, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 97, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 74, 83, 79, 78, 83, 116, 114, 105, 110, 103, 40, 106, 115, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 119, 114, 97, 112, 79, 98, 106, 101, 99, 116, 40, 64, 106, 115, 111, 110, 80, 97, 114, 115, 101, 40, 106, 115, 111, 110, 83, 116, 114, 105, 110, 103, 41, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 116, 114, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 84, 97, 98, 108, 101, 40, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 116, 97, 98, 108, 101, 44, 32, 99, 111, 108, 117, 109, 110, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 116, 97, 98, 108, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 111, 108, 117, 109, 110, 115, 32, 61, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 108, 117, 109, 110, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 99, 111, 108, 117, 109, 110, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 99, 111, 108, 117, 109, 110, 115, 41, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 111, 108, 117, 109, 110, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 111, 108, 117, 109, 110, 115, 91, 105, 93, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 116, 97, 98, 108, 101, 44, 32, 34, 99, 111, 110, 115, 111, 108, 101, 34, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 101, 116, 69, 118, 101, 110, 116, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 108, 101, 97, 114, 69, 118, 101, 110, 116, 86, 97, 108, 117, 101, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 101, 116, 69, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 108, 101, 97, 114, 69, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 105, 110, 100, 79, 98, 106, 101, 99, 116, 66, 121, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 99, 111, 110, 115, 111, 108, 101, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 103, 114, 111, 117, 112, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 103, 114, 111, 117, 112, 91, 105, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 114, 101, 97, 116, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 79, 98, 106, 101, 99, 116, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 124, 124, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 104, 97, 115, 73, 110, 106, 101, 99, 116, 101, 100, 77, 111, 100, 117, 108, 101, 40, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 77, 111, 100, 117, 108, 101, 40, 110, 97, 109, 101, 44, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 104, 111, 115, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 69, 114, 114, 111, 114, 58, 32, 87, 101, 98, 32, 73, 110, 115, 112, 101, 99, 116, 111, 114, 58, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 119, 97, 115, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 102, 111, 114, 32, 105, 110, 106, 101, 99, 116, 77, 111, 100, 117, 108, 101, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 44, 32, 116, 104, 105, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 34, 44, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 44, 32, 104, 111, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 111, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 98, 105, 110, 100, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 66, 111, 117, 110, 100, 79, 98, 106, 101, 99, 116, 73, 100, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 96, 123, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 58, 36, 123, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 125, 44, 34, 105, 100, 34, 58, 36, 123, 105, 100, 125, 125, 96, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 105, 100, 93, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 103, 114, 111, 117, 112, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 32, 61, 32, 103, 114, 111, 117, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 103, 114, 111, 117, 112, 44, 32, 105, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 105, 100, 93, 32, 61, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 73, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 105, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 105, 100, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 105, 100, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 46, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 46, 111, 98, 106, 101, 99, 116, 73, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 32, 124, 124, 32, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 91, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 93, 32, 33, 61, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 65, 114, 103, 117, 109, 101, 110, 116, 115, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 108, 111, 110, 103, 32, 116, 111, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 74, 97, 118, 97, 83, 99, 114, 105, 112, 116, 32, 119, 111, 114, 108, 100, 32, 97, 115, 32, 116, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 111, 98, 106, 101, 99, 116, 46, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 102, 117, 110, 99, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 102, 117, 110, 99, 40, 41, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 32, 38, 38, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 32, 61, 32, 116, 104, 105, 115, 46, 99, 114, 101, 97, 116, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 79, 98, 106, 101, 99, 116, 40, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 63, 32, 111, 98, 106, 101, 99, 116, 32, 58, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 99, 97, 108, 108, 70, 114, 97, 109, 101, 70, 111, 114, 73, 100, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 67, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 114, 100, 105, 110, 97, 108, 32, 61, 32, 112, 97, 114, 115, 101, 100, 67, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 91, 34, 111, 114, 100, 105, 110, 97, 108, 34, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 45, 45, 111, 114, 100, 105, 110, 97, 108, 32, 62, 61, 32, 48, 32, 38, 38, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 97, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 123, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 125, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 116, 97, 114, 116, 32, 61, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 124, 124, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 117, 110, 116, 32, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 124, 124, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 32, 61, 32, 33, 115, 116, 97, 114, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 115, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 103, 101, 116, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 101, 116, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 121, 109, 98, 111, 108, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 32, 38, 38, 32, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 61, 32, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 32, 33, 61, 61, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 61, 32, 99, 111, 117, 110, 116, 41, 32, 63, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 32, 58, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 34, 44, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 109, 112, 108, 101, 116, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 103, 101, 116, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 108, 101, 116, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 123, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 44, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 125, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 97, 100, 100, 40, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 111, 98, 106, 101, 99, 116, 91, 110, 97, 109, 101, 93, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 114, 105, 116, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 114, 105, 116, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 105, 110, 115, 116, 97, 110, 99, 101, 111, 102, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 101, 100, 87, 105, 116, 104, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 64, 99, 97, 116, 99, 104, 40, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 123, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 38, 38, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 104, 97, 115, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 97, 100, 100, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 121, 109, 98, 111, 108, 32, 61, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 32, 63, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 58, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 83, 116, 114, 105, 110, 103, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 41, 46, 64, 101, 110, 100, 115, 87, 105, 116, 104, 40, 34, 91, 110, 97, 116, 105, 118, 101, 32, 99, 111, 100, 101, 93, 92, 110, 125, 34, 41, 32, 124, 124, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 32, 38, 38, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 104, 97, 115, 79, 119, 110, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 34, 103, 101, 116, 34, 41, 32, 38, 38, 32, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 32, 38, 38, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 104, 97, 115, 79, 119, 110, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 34, 115, 101, 116, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 32, 61, 32, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 38, 38, 32, 64, 105, 115, 70, 105, 110, 105, 116, 101, 40, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 41, 32, 38, 38, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 111, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 32, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 41, 59, 32, 111, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 79, 102, 40, 111, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 111, 32, 61, 61, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 38, 38, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 111, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 111, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 105, 41, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 91, 105, 93, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 40, 111, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 91, 105, 93, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 114, 105, 116, 97, 98, 108, 101, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 115, 79, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 64, 98, 117, 105, 108, 116, 105, 110, 83, 101, 116, 73, 116, 101, 114, 97, 98, 108, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 118, 97, 108, 117, 101, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 38, 38, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 91, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 93, 32, 111, 102, 32, 64, 98, 117, 105, 108, 116, 105, 110, 77, 97, 112, 73, 116, 101, 114, 97, 98, 108, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 107, 101, 121, 34, 44, 32, 107, 101, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 38, 38, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 87, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 87, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 115, 117, 98, 116, 121, 112, 101, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 87, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 87, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 121, 112, 101, 34, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 124, 124, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 32, 61, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 105, 110, 100, 101, 120, 79, 102, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 91, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 93, 32, 61, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 49, 48, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 34, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 48, 44, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 49, 44, 32, 47, 47, 10, 32, 32, 32, 32, 34, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 50, 44, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 41, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 34, 67, 111, 110, 116, 105, 110, 117, 101, 34, 44, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 105, 118, 97, 116, 101, 83, 121, 109, 98, 111, 108, 40, 34, 99, 111, 110, 116, 105, 110, 117, 101, 34, 41, 44, 10, 32, 32, 32, 32, 34, 83, 116, 111, 112, 34, 44, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 105, 118, 97, 116, 101, 83, 121, 109, 98, 111, 108, 40, 34, 115, 116, 111, 112, 34, 41, 44, 10, 41, 59, 10, 10, 118, 97, 114, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 61, 32, 110, 101, 119, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 59, 10, 10, 47, 47, 10, 10, 108, 101, 116, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 99, 108, 97, 115, 115, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 32, 38, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 32, 38, 38, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 118, 97, 108, 117, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 34, 110, 117, 108, 108, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 98, 105, 110, 100, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 115, 117, 98, 116, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 110, 116, 101, 114, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 32, 63, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 115, 105, 122, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 77, 97, 112, 83, 105, 122, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 83, 101, 116, 83, 105, 122, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 32, 38, 38, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 112, 114, 111, 120, 121, 84, 97, 114, 103, 101, 116, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 101, 114, 114, 111, 114, 40, 101, 120, 46, 109, 101, 115, 115, 97, 103, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 60, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 110, 118, 101, 114, 116, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 32, 116, 111, 32, 115, 116, 114, 105, 110, 103, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 32, 38, 38, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 112, 114, 101, 118, 105, 101, 119, 32, 124, 124, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 95, 101, 109, 112, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 110, 117, 108, 108, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 97, 114, 114, 97, 121, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 46, 115, 112, 108, 105, 99, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 32, 38, 38, 32, 64, 105, 115, 70, 105, 110, 105, 116, 101, 40, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 97, 114, 114, 97, 121, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 100, 101, 115, 99, 114, 105, 98, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 100, 97, 116, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 101, 114, 114, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 80, 114, 111, 120, 121, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 111, 100, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 110, 116, 101, 114, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 32, 38, 38, 32, 64, 64, 116, 111, 83, 116, 114, 105, 110, 103, 84, 97, 103, 32, 105, 110, 32, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 46, 64, 64, 116, 111, 83, 116, 114, 105, 110, 103, 84, 97, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 46, 116, 111, 83, 116, 114, 105, 110, 103, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 79, 98, 106, 101, 99, 116, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 110, 111, 100, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 88, 77, 76, 68, 111, 99, 117, 109, 101, 110, 116, 32, 61, 32, 110, 111, 100, 101, 46, 111, 119, 110, 101, 114, 68, 111, 99, 117, 109, 101, 110, 116, 32, 38, 38, 32, 33, 33, 110, 111, 100, 101, 46, 111, 119, 110, 101, 114, 68, 111, 99, 117, 109, 101, 110, 116, 46, 120, 109, 108, 86, 101, 114, 115, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 61, 32, 105, 115, 88, 77, 76, 68, 111, 99, 117, 109, 101, 110, 116, 32, 63, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 78, 97, 109, 101, 32, 58, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 78, 97, 109, 101, 46, 116, 111, 76, 111, 119, 101, 114, 67, 97, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 110, 111, 100, 101, 46, 110, 111, 100, 101, 84, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 49, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 46, 105, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 105, 100, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 105, 100, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 46, 99, 108, 97, 115, 115, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 99, 108, 97, 115, 115, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 99, 108, 97, 115, 115, 76, 105, 115, 116, 46, 116, 111, 83, 116, 114, 105, 110, 103, 40, 41, 46, 114, 101, 112, 108, 97, 99, 101, 40, 47, 92, 115, 43, 47, 44, 32, 34, 32, 34, 41, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 105, 110, 112, 117, 116, 34, 32, 38, 38, 32, 110, 111, 100, 101, 46, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 116, 121, 112, 101, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 116, 121, 112, 101, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 51, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 86, 97, 108, 117, 101, 32, 43, 32, 34, 92, 34, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 56, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 33, 45, 45, 34, 32, 43, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 86, 97, 108, 117, 101, 32, 43, 32, 34, 45, 45, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 49, 48, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 33, 68, 79, 67, 84, 89, 80, 69, 32, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 111, 100, 101, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 44, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 124, 124, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 46, 118, 97, 108, 117, 101, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 108, 111, 115, 115, 108, 101, 115, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 110, 117, 108, 108, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 105, 122, 101, 34, 32, 105, 110, 32, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 115, 105, 122, 101, 32, 61, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 109, 112, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 61, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 32, 61, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 63, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 46, 108, 101, 110, 103, 116, 104, 32, 58, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 63, 32, 49, 48, 48, 48, 32, 58, 32, 109, 97, 120, 40, 53, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 100, 101, 120, 101, 115, 34, 44, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 63, 32, 49, 48, 48, 48, 32, 58, 32, 109, 97, 120, 40, 49, 48, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 69, 110, 116, 114, 121, 80, 114, 101, 118, 105, 101, 119, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 91, 105, 93, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 105, 110, 116, 101, 114, 110, 97, 108, 34, 44, 32, 116, 114, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 123, 105, 110, 116, 101, 114, 110, 97, 108, 125, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 97, 115, 84, 104, 114, 111, 119, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 32, 61, 61, 61, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 79, 98, 106, 101, 99, 116, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 82, 101, 103, 69, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 38, 38, 32, 33, 105, 115, 85, 73, 110, 116, 51, 50, 40, 110, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 38, 38, 32, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 38, 38, 32, 33, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 124, 124, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 41, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 38, 38, 32, 33, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 105, 110, 99, 108, 117, 100, 101, 115, 46, 64, 99, 97, 108, 108, 40, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 110, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 112, 114, 111, 112, 101, 114, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 111, 83, 116, 114, 105, 110, 103, 40, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 32, 62, 62, 62, 32, 48, 41, 32, 61, 61, 61, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 105, 110, 100, 101, 120, 101, 115, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 45, 45, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 105, 110, 100, 101, 120, 101, 115, 32, 60, 32, 48, 32, 124, 124, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 116, 101, 114, 110, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 105, 110, 116, 101, 114, 110, 97, 108, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 34, 97, 99, 99, 101, 115, 115, 111, 114, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 34, 111, 98, 106, 101, 99, 116, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 115, 117, 98, 116, 121, 112, 101, 34, 44, 32, 34, 110, 117, 108, 108, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 34, 110, 117, 108, 108, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 116, 121, 112, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 38, 38, 32, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 121, 112, 101, 32, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 49, 48, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 115, 117, 98, 116, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 32, 124, 124, 32, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 80, 114, 101, 118, 105, 101, 119, 32, 61, 32, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 32, 124, 124, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 99, 108, 97, 115, 115, 32, 34, 32, 43, 32, 118, 97, 108, 117, 101, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 111, 100, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 112, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 112, 112, 101, 110, 100, 69, 110, 116, 114, 121, 80, 114, 101, 118, 105, 101, 119, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 44, 32, 48, 44, 32, 54, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 53, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 112, 111, 112, 46, 64, 99, 97, 108, 108, 40, 101, 110, 116, 114, 105, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 109, 97, 112, 46, 64, 99, 97, 108, 108, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 44, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 107, 101, 121, 34, 32, 105, 110, 32, 101, 110, 116, 114, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 101, 116, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 101, 116, 46, 64, 97, 100, 100, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 118, 97, 108, 117, 101, 44, 32, 115, 101, 116, 44, 32, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 62, 32, 51, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 46, 64, 104, 97, 115, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 101, 112, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 46, 64, 97, 100, 100, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 62, 32, 53, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 91, 105, 93, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 32, 38, 38, 32, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 51, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 61, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 38, 38, 32, 33, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 93, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 109, 105, 100, 100, 108, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 60, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 105, 100, 100, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 108, 101, 102, 116, 72, 97, 108, 102, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 62, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 108, 101, 102, 116, 72, 97, 108, 102, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 48, 44, 32, 108, 101, 102, 116, 72, 97, 108, 102, 41, 32, 43, 32, 34, 92, 117, 50, 48, 50, 54, 34, 32, 43, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 44, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 48, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 43, 32, 34, 92, 117, 50, 48, 50, 54, 34, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 47, 47, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 32, 61, 32, 99, 108, 97, 115, 115, 32, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 111, 114, 100, 105, 110, 97, 108, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 61, 32, 96, 123, 34, 111, 114, 100, 105, 110, 97, 108, 34, 58, 36, 123, 111, 114, 100, 105, 110, 97, 108, 125, 44, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 58, 36, 123, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 125, 125, 96, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 111, 99, 97, 116, 105, 111, 110, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 115, 99, 114, 105, 112, 116, 73, 100, 34, 44, 32, 64, 83, 116, 114, 105, 110, 103, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 111, 117, 114, 99, 101, 73, 68, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 108, 105, 110, 101, 78, 117, 109, 98, 101, 114, 34, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 108, 105, 110, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 99, 111, 108, 117, 109, 110, 78, 117, 109, 98, 101, 114, 34, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 111, 108, 117, 109, 110, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 32, 61, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 83, 99, 111, 112, 101, 67, 104, 97, 105, 110, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 104, 105, 115, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 116, 104, 105, 115, 79, 98, 106, 101, 99, 116, 44, 32, 34, 98, 97, 99, 107, 116, 114, 97, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 105, 115, 84, 97, 105, 108, 68, 101, 108, 101, 116, 101, 100, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 105, 115, 84, 97, 105, 108, 68, 101, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 83, 99, 111, 112, 101, 67, 104, 97, 105, 110, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 91, 105, 93, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 99, 114, 101, 97, 116, 101, 83, 99, 111, 112, 101, 74, 115, 111, 110, 40, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 91, 105, 93, 44, 32, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 91, 105, 93, 44, 32, 34, 98, 97, 99, 107, 116, 114, 97, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 95, 99, 114, 101, 97, 116, 101, 83, 99, 111, 112, 101, 74, 115, 111, 110, 40, 111, 98, 106, 101, 99, 116, 44, 32, 123, 110, 97, 109, 101, 44, 32, 116, 121, 112, 101, 44, 32, 108, 111, 99, 97, 116, 105, 111, 110, 125, 44, 32, 103, 114, 111, 117, 112, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 111, 98, 106, 101, 99, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 73, 100, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 115, 99, 111, 112, 101, 84, 121, 112, 101, 78, 97, 109, 101, 115, 91, 116, 121, 112, 101, 93, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 110, 97, 109, 101, 32, 61, 32, 110, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 111, 99, 97, 116, 105, 111, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 108, 111, 99, 97, 116, 105, 111, 110, 32, 61, 32, 108, 111, 99, 97, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 69, 109, 112, 116, 121, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 101, 109, 112, 116, 121, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 99, 111, 112, 101, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 115, 99, 111, 112, 101, 84, 121, 112, 101, 78, 97, 109, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 48, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 49, 44, 32, 34, 119, 105, 116, 104, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 50, 44, 32, 34, 99, 108, 111, 115, 117, 114, 101, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 51, 44, 32, 34, 99, 97, 116, 99, 104, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 52, 44, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 53, 44, 32, 34, 103, 108, 111, 98, 97, 108, 76, 101, 120, 105, 99, 97, 108, 69, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 54, 44, 32, 34, 110, 101, 115, 116, 101, 100, 76, 101, 120, 105, 99, 97, 108, 34, 44, 32, 47, 47, 10, 41, 59, 10, 10, 47, 47, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 59, 10, 10, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 32, 61, 32, 40, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 44, 32, 119, 114, 97, 112, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 119, 114, 97, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 114, 105, 103, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 111, 114, 105, 103, 105, 110, 97, 108, 86, 97, 108, 117, 101, 59, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 100, 101, 102, 105, 110, 101, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 104, 105, 115, 44, 32, 34, 36, 34, 32, 43, 32, 107, 101, 121, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 103, 101, 116, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 38, 38, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 33, 61, 61, 32, 34, 36, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 100, 101, 102, 105, 110, 101, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 104, 105, 115, 44, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 43, 32, 107, 101, 121, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 103, 101, 116, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 95, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 101, 120, 99, 101, 112, 116, 105, 111, 110, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 101, 118, 101, 110, 116, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 105, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 91, 105, 93, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 110, 97, 109, 101, 44, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 91, 110, 97, 109, 101, 93, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 110, 97, 109, 101, 93, 59, 10, 125, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 107, 101, 121, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 107, 101, 121, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 118, 97, 108, 117, 101, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 118, 97, 108, 117, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 79, 98, 106, 101, 99, 116, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 72, 111, 108, 100, 101, 114, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 72, 111, 108, 100, 101, 114, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 105, 110, 115, 112, 101, 99, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 97, 115, 115, 101, 114, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 97, 115, 115, 101, 114, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 108, 101, 97, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 108, 101, 97, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 111, 117, 110, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 111, 117, 110, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 111, 117, 110, 116, 82, 101, 115, 101, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 111, 117, 110, 116, 82, 101, 115, 101, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 101, 98, 117, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 101, 98, 117, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 105, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 105, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 105, 114, 120, 109, 108, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 105, 114, 120, 109, 108, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 101, 114, 114, 111, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 101, 114, 114, 111, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 67, 111, 108, 108, 97, 112, 115, 101, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 67, 111, 108, 108, 97, 112, 115, 101, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 105, 110, 102, 111, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 105, 110, 102, 111, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 108, 111, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 108, 111, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 112, 114, 111, 102, 105, 108, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 112, 114, 111, 102, 105, 108, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 112, 114, 111, 102, 105, 108, 101, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 112, 114, 111, 102, 105, 108, 101, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 114, 101, 99, 111, 114, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 114, 101, 99, 111, 114, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 114, 101, 99, 111, 114, 100, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 114, 101, 99, 111, 114, 100, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 115, 99, 114, 101, 101, 110, 115, 104, 111, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 115, 99, 114, 101, 101, 110, 115, 104, 111, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 97, 98, 108, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 97, 98, 108, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 97, 107, 101, 72, 101, 97, 112, 83, 110, 97, 112, 115, 104, 111, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 97, 107, 101, 72, 101, 97, 112, 83, 110, 97, 112, 115, 104, 111, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 76, 111, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 76, 111, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 83, 116, 97, 109, 112, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 83, 116, 97, 109, 112, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 114, 97, 99, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 114, 97, 99, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 119, 97, 114, 110, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 119, 97, 114, 110, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 10, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 41, 10, 32, 32, 32, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 110, 97, 109, 101, 93, 46, 116, 111, 83, 116, 114, 105, 110, 103, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 32, 34, 32, 43, 32, 110, 97, 109, 101, 32, 43, 32, 34, 40, 41, 32, 123, 32, 91, 67, 111, 109, 109, 97, 110, 100, 32, 76, 105, 110, 101, 32, 65, 80, 73, 93, 32, 125, 34, 59, 32, 125, 59, 10, 10, 114, 101, 116, 117, 114, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 37, 32, 50, 32, 33, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 96, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 96, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 101, 97, 99, 104, 32, 107, 101, 121, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 102, 111, 108, 108, 111, 119, 101, 100, 32, 98, 121, 32, 97, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 108, 116, 105, 110, 103, 32, 105, 110, 32, 97, 110, 32, 101, 118, 101, 110, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 43, 61, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 98, 106, 101, 99, 116, 91, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 93, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 32, 43, 32, 49, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 58, 32, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 58, 32, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 58, 32, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 58, 32, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 100, 101, 108, 101, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 108, 101, 116, 101, 32, 116, 97, 114, 103, 101, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 93, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 32, 124, 124, 32, 33, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 64, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 46, 107, 101, 121, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 32, 38, 38, 32, 64, 105, 115, 83, 117, 115, 112, 101, 110, 100, 89, 105, 101, 108, 100, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 32, 61, 32, 64, 110, 101, 119, 82, 101, 103, 105, 115, 116, 114, 121, 69, 110, 116, 114, 121, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 115, 101, 116, 40, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 101, 118, 97, 108, 117, 97, 116, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 32, 33, 61, 61, 32, 39, 115, 116, 114, 105, 110, 103, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 101, 118, 97, 108, 117, 97, 116, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 124, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 124, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 115, 116, 114, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 101, 118, 97, 108, 73, 110, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 44, 32, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 41, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 40, 116, 114, 117, 101, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 101, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 102, 105, 110, 97, 108, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 99, 117, 114, 114, 101, 110, 116, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 110, 101, 120, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 112, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 107, 101, 112, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 101, 112, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 116, 104, 105, 115, 41, 32, 33, 61, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 102, 114, 111, 109, 32, 124, 116, 104, 105, 115, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 107, 101, 112, 116, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 40, 48, 44, 32, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 40, 41, 32, 61, 62, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 40, 41, 32, 61, 62, 32, 123, 32, 116, 104, 114, 111, 119, 32, 114, 101, 97, 115, 111, 110, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 86, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 86, 97, 108, 117, 101, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 107, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 120, 101, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 116, 116, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 100, 101, 112, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 100, 101, 112, 116, 104, 78, 117, 109, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 62, 32, 48, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 32, 45, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 44, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 87, 105, 116, 104, 67, 97, 108, 108, 98, 97, 99, 107, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 108, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 99, 111, 108, 111, 114, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 99, 111, 108, 111, 114, 34, 44, 32, 99, 111, 108, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 105, 122, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 115, 105, 122, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 115, 105, 122, 101, 34, 44, 32, 115, 105, 122, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 77, 97, 112, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 101, 121, 44, 32, 107, 101, 121, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 109, 97, 112, 70, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 41, 32, 58, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 109, 97, 112, 70, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 112, 70, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 70, 114, 111, 109, 70, 97, 115, 116, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 99, 111, 117, 110, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 99, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 99, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 123, 125, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 79, 98, 106, 101, 99, 116, 46, 102, 114, 111, 109, 69, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 105, 116, 101, 114, 97, 98, 108, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 121, 105, 101, 108, 100, 115, 32, 111, 98, 106, 101, 99, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 91, 48, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 101, 110, 116, 114, 121, 91, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 111, 114, 99, 101, 70, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 105, 108, 80, 111, 115, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 116, 97, 114, 116, 32, 61, 32, 48, 59, 32, 115, 116, 97, 114, 116, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 79, 102, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 34, 36, 34, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 44, 32, 115, 116, 97, 114, 116, 32, 33, 61, 61, 32, 45, 49, 59, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 45, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 62, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 91, 115, 116, 97, 114, 116, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 36, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 38, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 109, 97, 116, 99, 104, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 96, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 48, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 39, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 105, 108, 80, 111, 115, 32, 60, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 116, 97, 105, 108, 80, 111, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 60, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 32, 61, 32, 115, 116, 97, 114, 116, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 79, 102, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 34, 62, 34, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 91, 103, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 116, 117, 114, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 60, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 67, 111, 100, 101, 32, 61, 32, 99, 104, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 99, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 32, 61, 32, 99, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 62, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 60, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 110, 32, 61, 32, 49, 48, 32, 42, 32, 110, 32, 43, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 110, 32, 60, 61, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 32, 61, 32, 110, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 61, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 91, 110, 32, 45, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 99, 97, 112, 116, 117, 114, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 103, 114, 111, 117, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 103, 114, 111, 117, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 116, 111, 80, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 32, 61, 32, 103, 114, 111, 117, 112, 115, 91, 107, 101, 121, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 115, 44, 32, 107, 101, 121, 44, 32, 103, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 44, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 103, 114, 111, 117, 112, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 103, 114, 111, 117, 112, 84, 111, 77, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 103, 114, 111, 117, 112, 84, 111, 77, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 115, 32, 61, 32, 110, 101, 119, 32, 64, 77, 97, 112, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 32, 61, 32, 103, 114, 111, 117, 112, 115, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 115, 46, 64, 115, 101, 116, 40, 107, 101, 121, 44, 32, 103, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 44, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 103, 114, 111, 117, 112, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 104, 97, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 32, 105, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 102, 108, 97, 103, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 70, 108, 97, 103, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 105, 103, 110, 111, 114, 101, 67, 97, 115, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 109, 117, 108, 116, 105, 108, 105, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 77, 117, 108, 116, 105, 108, 105, 110, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 116, 105, 99, 107, 121, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 116, 105, 99, 107, 121, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 111, 117, 114, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 111, 117, 114, 99, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 109, 97, 116, 99, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 116, 121, 112, 101, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 108, 97, 99, 101, 114, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 116, 121, 112, 101, 83, 121, 109, 98, 111, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 112, 101, 99, 105, 102, 105, 101, 114, 44, 32, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 105, 109, 112, 111, 114, 116, 86, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 114, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 112, 101, 99, 105, 102, 105, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 111, 107, 117, 112, 66, 105, 110, 100, 105, 110, 103, 32, 61, 32, 40, 109, 111, 100, 117, 108, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 111, 107, 117, 112, 32, 61, 32, 109, 111, 100, 117, 108, 101, 91, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 83, 116, 114, 105, 110, 103, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 111, 111, 107, 117, 112, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 105, 109, 112, 111, 114, 116, 86, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 124, 32, 116, 111, 32, 101, 120, 105, 115, 116, 32, 105, 110, 32, 116, 104, 101, 32, 124, 115, 112, 101, 99, 105, 102, 105, 101, 114, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 40, 116, 114, 117, 101, 44, 32, 116, 104, 105, 115, 44, 32, 108, 111, 111, 107, 117, 112, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 111, 115, 115, 82, 101, 97, 108, 109, 84, 104, 114, 111, 119, 32, 61, 32, 40, 101, 114, 114, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 101, 114, 114, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 109, 112, 111, 114, 116, 73, 110, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 44, 32, 115, 112, 101, 99, 105, 102, 105, 101, 114, 83, 116, 114, 105, 110, 103, 41, 46, 64, 116, 104, 101, 110, 40, 108, 111, 111, 107, 117, 112, 66, 105, 110, 100, 105, 110, 103, 44, 32, 99, 114, 111, 115, 115, 82, 101, 97, 108, 109, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 110, 99, 108, 117, 100, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 102, 114, 111, 109, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 62, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 61, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 124, 124, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 109, 112, 111, 114, 116, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 115, 111, 117, 114, 99, 101, 41, 46, 64, 116, 104, 101, 110, 40, 40, 115, 111, 117, 114, 99, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 40, 115, 111, 117, 114, 99, 101, 44, 32, 105, 109, 112, 111, 114, 116, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 44, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 44, 32, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 106, 101, 99, 116, 40, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 32, 124, 124, 32, 64, 105, 115, 68, 101, 114, 105, 118, 101, 100, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 120, 121, 79, 98, 106, 101, 99, 116, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 115, 65, 114, 114, 97, 121, 83, 108, 111, 119, 40, 97, 114, 114, 97, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 118, 97, 108, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 89, 105, 101, 108, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 116, 97, 108, 105, 99, 115, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 105, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 124, 124, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 46, 105, 115, 65, 115, 121, 110, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 115, 65, 115, 121, 110, 99, 32, 61, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 68, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 32, 124, 124, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 32, 61, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 104, 114, 101, 102, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 100, 32, 121, 101, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 111, 97, 100, 77, 111, 100, 117, 108, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 44, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 116, 104, 105, 115, 41, 32, 33, 61, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 102, 114, 111, 109, 32, 124, 116, 104, 105, 115, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 77, 97, 112, 66, 117, 99, 107, 101, 116, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 107, 101, 121, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 116, 99, 104, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 103, 101, 120, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 109, 97, 116, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 69, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 77, 97, 116, 99, 104, 101, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 69, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 110, 101, 119, 32, 77, 97, 116, 99, 104, 101, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 116, 99, 104, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 109, 97, 116, 99, 104, 101, 114, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 97, 114, 103, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 97, 114, 103, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 97, 114, 103, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 109, 97, 116, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 97, 114, 103, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 97, 114, 103, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 103, 69, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 32, 61, 32, 49, 48, 48, 48, 48, 48, 48, 48, 48, 59, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 44, 32, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 44, 32, 98, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 32, 60, 32, 98, 41, 32, 63, 32, 98, 32, 58, 32, 97, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 44, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 60, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 32, 63, 32, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 58, 32, 112, 111, 115, 105, 116, 105, 118, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 105, 115, 65, 115, 121, 110, 99, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 46, 105, 115, 65, 115, 121, 110, 99, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 97, 115, 121, 110, 99, 77, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 58, 32, 112, 114, 111, 109, 105, 115, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 40, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 32, 61, 32, 114, 101, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 101, 121, 58, 32, 107, 101, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 58, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 58, 32, 91, 93, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 111, 100, 117, 108, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 69, 114, 114, 111, 114, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 58, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 100, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 65, 115, 121, 110, 99, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 65, 114, 114, 97, 121, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 97, 114, 114, 97, 121, 41, 32, 38, 38, 32, 64, 105, 115, 68, 101, 116, 97, 99, 104, 101, 100, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 85, 110, 100, 101, 114, 108, 121, 105, 110, 103, 32, 65, 114, 114, 97, 121, 66, 117, 102, 102, 101, 114, 32, 104, 97, 115, 32, 98, 101, 101, 110, 32, 100, 101, 116, 97, 99, 104, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 118, 105, 101, 119, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 72, 101, 108, 112, 101, 114, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 68, 111, 110, 101, 32, 61, 32, 33, 33, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 86, 97, 108, 117, 101, 32, 61, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 110, 101, 120, 116, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 110, 101, 120, 116, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 77, 97, 112, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 77, 97, 112, 66, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 82, 101, 103, 69, 120, 112, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 109, 97, 116, 99, 104, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 61, 61, 32, 34, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 105, 110, 103, 44, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 109, 97, 116, 99, 104, 44, 32, 100, 111, 110, 101, 58, 32, 102, 97, 108, 115, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 101, 116, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 62, 62, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 32, 124, 124, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 32, 61, 61, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 32, 43, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 108, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 107, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 107, 93, 41, 59, 10, 32, 32, 32, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 111, 102, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 108, 101, 110, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 111, 102, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 69, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 32, 43, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 83, 116, 97, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 43, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 83, 112, 114, 101, 97, 100, 32, 115, 121, 110, 116, 97, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 46, 46, 46, 105, 116, 101, 114, 97, 98, 108, 101, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 39, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 114, 97, 98, 108, 101, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 83, 112, 114, 101, 97, 100, 32, 115, 121, 110, 116, 97, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 46, 46, 46, 105, 116, 101, 114, 97, 98, 108, 101, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 46, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 109, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 116, 101, 109, 32, 61, 32, 110, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 116, 101, 109, 46, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 110, 100, 101, 120, 43, 43, 44, 32, 105, 116, 101, 109, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 69, 109, 112, 116, 121, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 69, 109, 112, 116, 121, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 116, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 41, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 116, 104, 101, 110, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 101, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 68, 101, 114, 105, 118, 101, 100, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 32, 38, 38, 32, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 68, 101, 114, 105, 118, 101, 100, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 62, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 102, 101, 116, 99, 104, 101, 100, 46, 34, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 117, 108, 102, 105, 108, 108, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 58, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 58, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 58, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 58, 32, 48, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 32, 61, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 32, 61, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 101, 109, 112, 108, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 101, 109, 112, 108, 97, 116, 101, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 46, 114, 97, 119, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 46, 114, 97, 119, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 39, 39, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 61, 32, 39, 39, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 115, 101, 103, 109, 101, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 105, 32, 43, 32, 49, 41, 32, 61, 61, 61, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 60, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 32, 61, 32, 105, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 43, 43, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 43, 43, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 45, 45, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 45, 45, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 62, 61, 32, 48, 59, 32, 107, 45, 45, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 120, 101, 99, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 101, 120, 101, 99, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 120, 101, 99, 32, 33, 61, 61, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 38, 38, 32, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 101, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 32, 38, 38, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 104, 101, 32, 114, 101, 115, 117, 108, 116, 32, 111, 102, 32, 97, 32, 82, 101, 103, 69, 120, 112, 32, 101, 120, 101, 99, 32, 109, 117, 115, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 82, 101, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 60, 32, 48, 32, 124, 124, 32, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 48, 32, 97, 110, 100, 32, 110, 111, 116, 32, 98, 101, 32, 73, 110, 102, 105, 110, 105, 116, 121, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 61, 32, 40, 99, 111, 117, 110, 116, 32, 47, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 32, 124, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 32, 61, 32, 99, 111, 117, 110, 116, 32, 45, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 42, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 105, 110, 103, 44, 32, 48, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 32, 124, 124, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 42, 32, 99, 111, 117, 110, 116, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 32, 61, 32, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 116, 99, 104, 83, 116, 114, 46, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 100, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 32, 63, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 48, 41, 32, 63, 32, 48, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 110, 32, 61, 32, 49, 59, 32, 110, 32, 60, 61, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 59, 32, 110, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 78, 32, 61, 32, 114, 101, 115, 117, 108, 116, 91, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 78, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 112, 78, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 103, 114, 111, 117, 112, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 32, 61, 32, 91, 32, 109, 97, 116, 99, 104, 101, 100, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 106, 32, 61, 32, 48, 59, 32, 106, 32, 60, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 106, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 91, 106, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 86, 97, 108, 117, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 46, 64, 97, 112, 112, 108, 121, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 91, 83, 121, 109, 98, 111, 108, 46, 114, 101, 112, 108, 97, 99, 101, 93, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 39, 103, 114, 111, 117, 112, 115, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 109, 97, 116, 99, 104, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 64, 103, 101, 116, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 46, 99, 97, 116, 99, 104, 40, 40, 101, 114, 114, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 61, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 102, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 115, 111, 117, 114, 99, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 111, 117, 114, 99, 101, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 103, 101, 116, 77, 111, 100, 117, 108, 101, 78, 97, 109, 101, 115, 112, 97, 99, 101, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 40, 97, 115, 121, 110, 99, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 32, 61, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 112, 97, 114, 115, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 40, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 78, 97, 109, 101, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 75, 101, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 83, 121, 110, 99, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 100, 101, 112, 75, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 44, 32, 105, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 46, 64, 115, 101, 116, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 83, 97, 116, 105, 115, 102, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 125, 41, 40, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 118, 105, 115, 105, 116, 101, 100, 46, 64, 97, 100, 100, 40, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 121, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 76, 111, 97, 100, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 105, 115, 105, 116, 101, 100, 46, 64, 104, 97, 115, 40, 100, 101, 112, 69, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 76, 111, 97, 100, 115, 44, 32, 105, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 46, 105, 110, 116, 101, 114, 110, 97, 108, 65, 108, 108, 40, 100, 101, 112, 76, 111, 97, 100, 115, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 105, 101, 115, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 32, 61, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 97, 32, 112, 114, 111, 109, 105, 115, 101, 32, 119, 105, 116, 104, 32, 105, 116, 115, 101, 108, 102, 34, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 101, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 101, 114, 114, 111, 114, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 101, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 124, 124, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 68, 111, 110, 101, 32, 61, 32, 33, 33, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 86, 97, 108, 117, 101, 32, 61, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 114, 101, 115, 117, 108, 116, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 114, 101, 115, 117, 108, 116, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 101, 97, 114, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 115, 97, 109, 101, 86, 97, 108, 117, 101, 40, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 48, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 115, 97, 109, 101, 86, 97, 108, 117, 101, 40, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 103, 101, 120, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 64, 115, 101, 97, 114, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 101, 97, 114, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 64, 115, 101, 97, 114, 99, 104, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 101, 116, 66, 117, 99, 107, 101, 116, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 32, 110, 101, 119, 83, 116, 97, 116, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 109, 97, 108, 108, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 109, 97, 108, 108, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 99, 101, 105, 118, 101, 114, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 99, 101, 105, 118, 101, 114, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 64, 115, 111, 114, 116, 67, 111, 109, 112, 97, 99, 116, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 111, 114, 116, 66, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 115, 111, 114, 116, 101, 100, 44, 32, 48, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 64, 115, 111, 114, 116, 67, 111, 109, 109, 105, 116, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 124, 124, 32, 64, 105, 115, 83, 104, 97, 114, 101, 100, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 116, 104, 105, 115, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 68, 101, 102, 97, 117, 108, 116, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 116, 104, 105, 115, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 111, 114, 116, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 100, 101, 112, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 32, 60, 32, 51, 50, 32, 124, 124, 32, 100, 101, 112, 116, 104, 32, 62, 32, 51, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 98, 117, 99, 107, 101, 116, 44, 32, 64, 115, 111, 114, 116, 83, 116, 114, 105, 110, 103, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 111, 114, 116, 101, 100, 91, 105, 93, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 115, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 68, 105, 114, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 98, 117, 99, 107, 101, 116, 115, 44, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 98, 117, 99, 107, 101, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 101, 110, 116, 114, 121, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 100, 101, 112, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 100, 101, 112, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 66, 117, 99, 107, 101, 116, 32, 61, 32, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 66, 117, 99, 107, 101, 116, 44, 32, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 98, 117, 99, 107, 101, 116, 115, 44, 32, 99, 44, 32, 91, 32, 101, 110, 116, 114, 121, 32, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 64, 115, 111, 114, 116, 66, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 44, 32, 100, 101, 112, 116, 104, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 115, 111, 114, 116, 101, 100, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 111, 114, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 60, 61, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 32, 38, 38, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 62, 61, 32, 54, 52, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 115, 111, 114, 116, 101, 100, 91, 48, 93, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 32, 123, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 112, 112, 101, 110, 100, 77, 101, 109, 99, 112, 121, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 32, 61, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 32, 61, 32, 115, 111, 114, 116, 101, 100, 91, 105, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 63, 32, 123, 115, 116, 114, 105, 110, 103, 58, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 44, 32, 118, 97, 108, 117, 101, 125, 32, 58, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 69, 110, 100, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 32, 61, 32, 115, 114, 99, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 108, 101, 102, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 32, 61, 32, 108, 101, 102, 116, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 114, 105, 103, 104, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 102, 116, 59, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 59, 32, 43, 43, 100, 115, 116, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 105, 103, 104, 116, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 102, 116, 32, 62, 61, 32, 108, 101, 102, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 105, 103, 104, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 102, 97, 108, 115, 101, 32, 124, 124, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 105, 103, 104, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 108, 101, 102, 116, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 102, 102, 101, 114, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 98, 117, 102, 102, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 97, 114, 114, 97, 121, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 119, 105, 100, 116, 104, 32, 61, 32, 49, 59, 32, 119, 105, 100, 116, 104, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 119, 105, 100, 116, 104, 32, 42, 61, 32, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 43, 61, 32, 50, 32, 42, 32, 119, 105, 100, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 109, 112, 32, 61, 32, 115, 114, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 114, 99, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 116, 109, 112, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 114, 99, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 44, 32, 98, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 83, 116, 114, 105, 110, 103, 32, 61, 32, 97, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 83, 116, 114, 105, 110, 103, 32, 61, 32, 98, 46, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 98, 83, 116, 114, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 48, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 83, 116, 114, 105, 110, 103, 32, 62, 32, 98, 83, 116, 114, 105, 110, 103, 32, 63, 32, 49, 32, 58, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 98, 106, 44, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 111, 98, 106, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 64, 115, 112, 101, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 91, 83, 121, 109, 98, 111, 108, 46, 115, 112, 101, 99, 105, 101, 115, 93, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 82, 101, 103, 69, 120, 112, 32, 38, 38, 32, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 101, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 119, 70, 108, 97, 103, 115, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 121, 34, 41, 32, 63, 32, 102, 108, 97, 103, 115, 32, 58, 32, 102, 108, 97, 103, 115, 32, 43, 32, 34, 121, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 110, 101, 119, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 110, 101, 119, 70, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 115, 112, 108, 105, 116, 116, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 105, 109, 105, 116, 32, 61, 32, 40, 108, 105, 109, 105, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 63, 32, 48, 120, 102, 102, 102, 102, 102, 102, 102, 102, 32, 58, 32, 108, 105, 109, 105, 116, 32, 62, 62, 62, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 122, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 122, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 48, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 115, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 101, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 63, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 58, 32, 115, 105, 122, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 115, 117, 98, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 49, 32, 63, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 32, 58, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 105, 32, 60, 61, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 115, 105, 122, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 46, 64, 64, 115, 112, 108, 105, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 112, 108, 105, 116, 116, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 116, 114, 105, 110, 103, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 116, 114, 105, 107, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 116, 114, 105, 107, 101, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 98, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 112, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 112, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 104, 97, 115, 73, 110, 115, 116, 97, 110, 99, 101, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 116, 104, 105, 115, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 110, 115, 116, 97, 110, 99, 101, 79, 102, 40, 118, 97, 108, 117, 101, 44, 32, 116, 97, 114, 103, 101, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 84, 101, 115, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 101, 115, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 80, 114, 111, 109, 105, 115, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 116, 104, 105, 115, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 116, 104, 114, 111, 119, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 68, 111, 110, 101, 32, 61, 32, 33, 33, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 86, 97, 108, 117, 101, 32, 61, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 116, 104, 114, 111, 119, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 116, 104, 114, 111, 119, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 112, 116, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 119, 101, 101, 107, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 80, 101, 114, 105, 111, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 102, 114, 97, 99, 116, 105, 111, 110, 97, 108, 83, 101, 99, 111, 110, 100, 68, 105, 103, 105, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 116, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 116, 105, 109, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 124, 124, 32, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 112, 116, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 119, 101, 101, 107, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 116, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 116, 105, 109, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 112, 116, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 80, 101, 114, 105, 111, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 102, 114, 97, 99, 116, 105, 111, 110, 97, 108, 83, 101, 99, 111, 110, 100, 68, 105, 103, 105, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 116, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 61, 32, 111, 112, 116, 105, 111, 110, 115, 46, 116, 105, 109, 101, 83, 116, 121, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 100, 97, 116, 101, 83, 116, 121, 108, 101, 32, 99, 97, 110, 110, 111, 116, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 105, 109, 101, 83, 116, 121, 108, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 43, 116, 97, 114, 103, 101, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 124, 124, 32, 33, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 48, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 114, 117, 110, 99, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 116, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 43, 40, 108, 101, 110, 103, 116, 104, 32, 62, 32, 48, 32, 63, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 32, 63, 32, 108, 101, 110, 103, 116, 104, 32, 58, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 32, 58, 32, 48, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 68, 97, 116, 101, 68, 97, 116, 101, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 65, 110, 121, 65, 108, 108, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 91, 48, 93, 46, 116, 111, 76, 111, 99, 97, 108, 101, 83, 116, 114, 105, 110, 103, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 44, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 32, 43, 61, 32, 34, 44, 34, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 91, 105, 93, 46, 116, 111, 76, 111, 99, 97, 108, 101, 83, 116, 114, 105, 110, 103, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 44, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 84, 105, 109, 101, 84, 105, 109, 101, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 82, 101, 118, 101, 114, 115, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 86, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 108, 101, 110, 103, 116, 104, 32, 45, 32, 107, 32, 45, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 102, 114, 111, 109, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 111, 114, 116, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 111, 114, 116, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 83, 111, 114, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 115, 117, 108, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 111, 114, 116, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 108, 111, 110, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 124, 124, 32, 64, 105, 115, 83, 104, 97, 114, 101, 100, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 114, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 68, 101, 102, 97, 117, 108, 116, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 111, 114, 116, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 114, 116, 44, 32, 100, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 112, 108, 105, 99, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 115, 116, 97, 114, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 62, 32, 48, 32, 63, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 64, 109, 105, 110, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 50, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 100, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 62, 32, 48, 32, 63, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 64, 109, 105, 110, 40, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 44, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 119, 76, 101, 110, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 45, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 119, 76, 101, 110, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 110, 101, 119, 76, 101, 110, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 59, 32, 105, 43, 43, 44, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 32, 43, 32, 50, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 110, 101, 119, 76, 101, 110, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 107, 32, 43, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 45, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 102, 114, 111, 109, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 58, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 99, 111, 117, 110, 116, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 32, 105, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 105, 32, 43, 61, 32, 51, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 32, 43, 32, 49, 93, 32, 58, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 32, 43, 32, 50, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 105, 32, 61, 61, 61, 32, 99, 111, 117, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 69, 110, 100, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 32, 61, 32, 115, 114, 99, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 108, 101, 102, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 32, 61, 32, 108, 101, 102, 116, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 114, 105, 103, 104, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 102, 116, 59, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 59, 32, 43, 43, 100, 115, 116, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 105, 103, 104, 116, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 102, 116, 32, 62, 61, 32, 108, 101, 102, 116, 69, 110, 100, 32, 124, 124, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 41, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 108, 101, 102, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 102, 102, 101, 114, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 98, 117, 102, 102, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 97, 114, 114, 97, 121, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 119, 105, 100, 116, 104, 32, 61, 32, 49, 59, 32, 119, 105, 100, 116, 104, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 119, 105, 100, 116, 104, 32, 42, 61, 32, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 43, 61, 32, 50, 32, 42, 32, 119, 105, 100, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 77, 101, 114, 103, 101, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 109, 112, 32, 61, 32, 115, 114, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 114, 99, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 116, 109, 112, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 114, 99, 32, 33, 61, 32, 97, 114, 114, 97, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 32, 115, 114, 99, 91, 105, 93, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 64, 115, 112, 101, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 119, 105, 116, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 32, 62, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 32, 124, 124, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 32, 105, 110, 100, 101, 120, 32, 111, 117, 116, 32, 111, 102, 32, 82, 97, 110, 103, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 61, 61, 61, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 114, 111, 109, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 44, 32, 115, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 44, 32, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 97, 114, 103, 101, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 109, 111, 116, 101, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 97, 114, 103, 101, 116, 44, 32, 102, 114, 111, 109, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 63, 32, 110, 117, 108, 108, 32, 58, 32, 115, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 118, 97, 108, 117, 101, 32, 112, 97, 115, 115, 105, 110, 103, 32, 98, 101, 116, 119, 101, 101, 110, 32, 114, 101, 97, 108, 109, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 32, 111, 114, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 34, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 119, 114, 97, 112, 112, 101, 114, 59, 10, 125, 41, 10 };

const unsigned s_JSCCombinedCodeLength = 194197;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeLength = 183;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCode =
s_JSCCombinedCode + 0
;

const JSC::ConstructAbility s_promiseConstructorInternalPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorInternalPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const JSC::ImplementationVisibility s_promiseConstructorInternalPromiseConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorInternalPromiseConstructorCodeLength = 685;
static const JSC::Intrinsic s_promiseConstructorInternalPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorInternalPromiseConstructorCode =
s_JSCCombinedCode + 183
;

const JSC::ConstructAbility s_promiseConstructorPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const JSC::ImplementationVisibility s_promiseConstructorPromiseConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorPromiseConstructorCodeLength = 678;
static const JSC::Intrinsic s_promiseConstructorPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseConstructorCode =
s_JSCCombinedCode + 868
;

const JSC::ConstructAbility s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeRegExpStringIteratorConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeRegExpStringIteratorConstructorCodeLength = 430;
static const JSC::Intrinsic s_regExpPrototypeRegExpStringIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpStringIteratorConstructorCode =
s_JSCCombinedCode + 1546
;

const JSC::ConstructAbility s_regExpPrototypeAdvanceStringIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeAdvanceStringIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeAdvanceStringIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeAdvanceStringIndexCodeLength = 427;
static const JSC::Intrinsic s_regExpPrototypeAdvanceStringIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeAdvanceStringIndexCode =
s_JSCCombinedCode + 1976
;

const JSC::ConstructAbility s_promiseConstructorAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorAllCodeLength = 1529;
static const JSC::Intrinsic s_promiseConstructorAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllCode =
s_JSCCombinedCode + 2403
;

const JSC::ConstructAbility s_promiseConstructorAllSettledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllSettledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAllSettledCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorAllSettledCodeLength = 2249;
static const JSC::Intrinsic s_promiseConstructorAllSettledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllSettledCode =
s_JSCCombinedCode + 3932
;

const JSC::ConstructAbility s_stringPrototypeAnchorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeAnchorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeAnchorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeAnchorCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeAnchorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeAnchorCode =
s_JSCCombinedCode + 6181
;

const JSC::ConstructAbility s_promiseConstructorAnyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAnyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAnyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorAnyCodeLength = 1523;
static const JSC::Intrinsic s_promiseConstructorAnyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAnyCode =
s_JSCCombinedCode + 6292
;

const JSC::ConstructAbility s_functionPrototypeApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeApplyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeApplyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_functionPrototypeApplyCodeLength = 113;
static const JSC::Intrinsic s_functionPrototypeApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeApplyCode =
s_JSCCombinedCode + 7815
;

const JSC::ConstructAbility s_reflectObjectApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectApplyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectApplyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_reflectObjectApplyCodeLength = 361;
static const JSC::Intrinsic s_reflectObjectApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectApplyCode =
s_JSCCombinedCode + 7928
;

const JSC::ConstructAbility s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayIteratorPrototypeArrayIteratorNextHelperCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayIteratorPrototypeArrayIteratorNextHelperCodeLength = 803;
static const JSC::Intrinsic s_arrayIteratorPrototypeArrayIteratorNextHelperCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeArrayIteratorNextHelperCode =
s_JSCCombinedCode + 8289
;

const JSC::ConstructAbility s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFunctionPrototypeAsyncFunctionResumeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncFunctionPrototypeAsyncFunctionResumeCodeLength = 1304;
static const JSC::Intrinsic s_asyncFunctionPrototypeAsyncFunctionResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFunctionPrototypeAsyncFunctionResumeCode =
s_JSCCombinedCode + 9092
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeLength = 510;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCode =
s_JSCCombinedCode + 10396
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeLength = 560;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCode =
s_JSCCombinedCode + 10906
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeLength = 787;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCode =
s_JSCCombinedCode + 11466
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeLength = 142;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCode =
s_JSCCombinedCode + 12253
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeLength = 374;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorRejectCode =
s_JSCCombinedCode + 12395
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeLength = 383;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResolveCode =
s_JSCCombinedCode + 12769
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeLength = 2198;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCode =
s_JSCCombinedCode + 13152
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeLength = 488;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorYieldCode =
s_JSCCombinedCode + 15350
;

const JSC::ConstructAbility s_moduleLoaderAsyncModuleEvaluationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderAsyncModuleEvaluationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderAsyncModuleEvaluationCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderAsyncModuleEvaluationCodeLength = 753;
static const JSC::Intrinsic s_moduleLoaderAsyncModuleEvaluationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderAsyncModuleEvaluationCode =
s_JSCCombinedCode + 15838
;

const JSC::ConstructAbility s_arrayPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeAtCodeLength = 323;
static const JSC::Intrinsic s_arrayPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeAtCode =
s_JSCCombinedCode + 16591
;

const JSC::ConstructAbility s_stringPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeAtCodeLength = 403;
static const JSC::Intrinsic s_stringPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeAtCode =
s_JSCCombinedCode + 16914
;

const JSC::ConstructAbility s_typedArrayPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeAtCodeLength = 221;
static const JSC::Intrinsic s_typedArrayPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeAtCode =
s_JSCCombinedCode + 17317
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAwaitValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAwaitValueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAwaitValueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeAwaitValueCodeLength = 256;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAwaitValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAwaitValueCode =
s_JSCCombinedCode + 17538
;

const JSC::ConstructAbility s_stringPrototypeBigCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBigCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBigCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeBigCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeBigCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBigCode =
s_JSCCombinedCode + 17794
;

const JSC::ConstructAbility s_functionPrototypeBindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeBindCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeBindCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_functionPrototypeBindCodeLength = 916;
static const JSC::Intrinsic s_functionPrototypeBindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeBindCode =
s_JSCCombinedCode + 17899
;

const JSC::ConstructAbility s_stringPrototypeBlinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBlinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBlinkCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeBlinkCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeBlinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBlinkCode =
s_JSCCombinedCode + 18815
;

const JSC::ConstructAbility s_stringPrototypeBoldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBoldCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBoldCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeBoldCodeLength = 104;
static const JSC::Intrinsic s_stringPrototypeBoldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBoldCode =
s_JSCCombinedCode + 18924
;

const JSC::ConstructAbility s_iteratorHelpersBuiltinMapIterableCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersBuiltinMapIterableCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersBuiltinMapIterableCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_iteratorHelpersBuiltinMapIterableCodeLength = 263;
static const JSC::Intrinsic s_iteratorHelpersBuiltinMapIterableCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersBuiltinMapIterableCode =
s_JSCCombinedCode + 19028
;

const JSC::ConstructAbility s_iteratorHelpersBuiltinSetIterableCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersBuiltinSetIterableCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersBuiltinSetIterableCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_iteratorHelpersBuiltinSetIterableCodeLength = 266;
static const JSC::Intrinsic s_iteratorHelpersBuiltinSetIterableCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersBuiltinSetIterableCode =
s_JSCCombinedCode + 19291
;

const JSC::ConstructAbility s_functionPrototypeCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeCallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeCallCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_functionPrototypeCallCodeLength = 247;
static const JSC::Intrinsic s_functionPrototypeCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeCallCode =
s_JSCCombinedCode + 19557
;

const JSC::ConstructAbility s_promisePrototypeCatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeCatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeCatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promisePrototypeCatchCodeLength = 93;
static const JSC::Intrinsic s_promisePrototypeCatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeCatchCode =
s_JSCCombinedCode + 19804
;

const JSC::ConstructAbility s_webAssemblyCompileStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyCompileStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_webAssemblyCompileStreamingCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_webAssemblyCompileStreamingCodeLength = 125;
static const JSC::Intrinsic s_webAssemblyCompileStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyCompileStreamingCode =
s_JSCCombinedCode + 19897
;

const JSC::ConstructAbility s_arrayPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeConcatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeConcatCodeLength = 472;
static const JSC::Intrinsic s_arrayPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatCode =
s_JSCCombinedCode + 20022
;

const JSC::ConstructAbility s_stringPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeConcatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeConcatCodeLength = 322;
static const JSC::Intrinsic s_stringPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeConcatCode =
s_JSCCombinedCode + 20494
;

const JSC::ConstructAbility s_arrayPrototypeConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeConcatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeConcatSlowPathCodeLength = 1555;
static const JSC::Intrinsic s_arrayPrototypeConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatSlowPathCode =
s_JSCCombinedCode + 20816
;

const JSC::ConstructAbility s_arrayPrototypeCopyWithinCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeCopyWithinCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeCopyWithinCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeCopyWithinCodeLength = 1367;
static const JSC::Intrinsic s_arrayPrototypeCopyWithinCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeCopyWithinCode =
s_JSCCombinedCode + 22371
;

const JSC::ConstructAbility s_injectedScriptSourceCreateArrayWithoutPrototypeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateArrayWithoutPrototypeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateArrayWithoutPrototypeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_injectedScriptSourceCreateArrayWithoutPrototypeCodeLength = 208;
static const JSC::Intrinsic s_injectedScriptSourceCreateArrayWithoutPrototypeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateArrayWithoutPrototypeCode =
s_JSCCombinedCode + 23738
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeLength = 244;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCode =
s_JSCCombinedCode + 23946
;

const JSC::ConstructAbility s_stringPrototypeCreateHTMLCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeCreateHTMLCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeCreateHTMLCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_stringPrototypeCreateHTMLCodeLength = 530;
static const JSC::Intrinsic s_stringPrototypeCreateHTMLCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeCreateHTMLCode =
s_JSCCombinedCode + 24190
;

const JSC::ConstructAbility s_injectedScriptSourceCreateInspectorInjectedScriptCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateInspectorInjectedScriptCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateInspectorInjectedScriptCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const int s_injectedScriptSourceCreateInspectorInjectedScriptCodeLength = 55207;
static const JSC::Intrinsic s_injectedScriptSourceCreateInspectorInjectedScriptCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateInspectorInjectedScriptCode =
s_JSCCombinedCode + 24720
;

const JSC::ConstructAbility s_injectedScriptSourceCreateObjectWithoutPrototypeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateObjectWithoutPrototypeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateObjectWithoutPrototypeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_injectedScriptSourceCreateObjectWithoutPrototypeCodeLength = 371;
static const JSC::Intrinsic s_injectedScriptSourceCreateObjectWithoutPrototypeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateObjectWithoutPrototypeCode =
s_JSCCombinedCode + 79927
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsCreateResolvingFunctionsCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsCreateResolvingFunctionsCodeLength = 545;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsCode =
s_JSCCombinedCode + 80298
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeLength = 559;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCode =
s_JSCCombinedCode + 80843
;

const JSC::ConstructAbility s_reflectObjectDeletePropertyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectDeletePropertyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectDeletePropertyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_reflectObjectDeletePropertyCodeLength = 212;
static const JSC::Intrinsic s_reflectObjectDeletePropertyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectDeletePropertyCode =
s_JSCCombinedCode + 81402
;

const JSC::ConstructAbility s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderDependencyKeysIfEvaluatedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderDependencyKeysIfEvaluatedCodeLength = 355;
static const JSC::Intrinsic s_moduleLoaderDependencyKeysIfEvaluatedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderDependencyKeysIfEvaluatedCode =
s_JSCCombinedCode + 81614
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeLength = 2534;
static const JSC::Intrinsic s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCode =
s_JSCCombinedCode + 81969
;

const JSC::ConstructAbility s_moduleLoaderEnsureRegisteredCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderEnsureRegisteredCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderEnsureRegisteredCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderEnsureRegisteredCodeLength = 218;
static const JSC::Intrinsic s_moduleLoaderEnsureRegisteredCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderEnsureRegisteredCode =
s_JSCCombinedCode + 84503
;

const JSC::ConstructAbility s_shadowRealmPrototypeEvaluateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeEvaluateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeEvaluateCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_shadowRealmPrototypeEvaluateCodeLength = 409;
static const JSC::Intrinsic s_shadowRealmPrototypeEvaluateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeEvaluateCode =
s_JSCCombinedCode + 84721
;

const JSC::ConstructAbility s_arrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeEveryCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeEveryCodeLength = 545;
static const JSC::Intrinsic s_arrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeEveryCode =
s_JSCCombinedCode + 85130
;

const JSC::ConstructAbility s_typedArrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeEveryCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeEveryCodeLength = 381;
static const JSC::Intrinsic s_typedArrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeEveryCode =
s_JSCCombinedCode + 85675
;

const JSC::ConstructAbility s_arrayPrototypeFillCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFillCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFillCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFillCodeLength = 901;
static const JSC::Intrinsic s_arrayPrototypeFillCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFillCode =
s_JSCCombinedCode + 86056
;

const JSC::ConstructAbility s_arrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFilterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFilterCodeLength = 708;
static const JSC::Intrinsic s_arrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFilterCode =
s_JSCCombinedCode + 86957
;

const JSC::ConstructAbility s_typedArrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFilterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeFilterCodeLength = 979;
static const JSC::Intrinsic s_typedArrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFilterCode =
s_JSCCombinedCode + 87665
;

const JSC::ConstructAbility s_promisePrototypeFinallyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeFinallyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeFinallyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promisePrototypeFinallyCodeLength = 1051;
static const JSC::Intrinsic s_promisePrototypeFinallyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeFinallyCode =
s_JSCCombinedCode + 88644
;

const JSC::ConstructAbility s_arrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFindCodeLength = 519;
static const JSC::Intrinsic s_arrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindCode =
s_JSCCombinedCode + 89695
;

const JSC::ConstructAbility s_typedArrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeFindCodeLength = 408;
static const JSC::Intrinsic s_typedArrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindCode =
s_JSCCombinedCode + 90214
;

const JSC::ConstructAbility s_arrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFindIndexCodeLength = 487;
static const JSC::Intrinsic s_arrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindIndexCode =
s_JSCCombinedCode + 90622
;

const JSC::ConstructAbility s_typedArrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeFindIndexCodeLength = 377;
static const JSC::Intrinsic s_typedArrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindIndexCode =
s_JSCCombinedCode + 91109
;

const JSC::ConstructAbility s_arrayPrototypeFindLastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindLastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindLastCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFindLastCodeLength = 531;
static const JSC::Intrinsic s_arrayPrototypeFindLastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindLastCode =
s_JSCCombinedCode + 91486
;

const JSC::ConstructAbility s_typedArrayPrototypeFindLastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindLastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindLastCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeFindLastCodeLength = 426;
static const JSC::Intrinsic s_typedArrayPrototypeFindLastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindLastCode =
s_JSCCombinedCode + 92017
;

const JSC::ConstructAbility s_arrayPrototypeFindLastIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindLastIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindLastIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFindLastIndexCodeLength = 496;
static const JSC::Intrinsic s_arrayPrototypeFindLastIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindLastIndexCode =
s_JSCCombinedCode + 92443
;

const JSC::ConstructAbility s_typedArrayPrototypeFindLastIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindLastIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindLastIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeFindLastIndexCodeLength = 386;
static const JSC::Intrinsic s_typedArrayPrototypeFindLastIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindLastIndexCode =
s_JSCCombinedCode + 92939
;

const JSC::ConstructAbility s_stringPrototypeFixedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFixedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFixedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeFixedCodeLength = 106;
static const JSC::Intrinsic s_stringPrototypeFixedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFixedCode =
s_JSCCombinedCode + 93325
;

const JSC::ConstructAbility s_arrayPrototypeFlatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFlatCodeLength = 438;
static const JSC::Intrinsic s_arrayPrototypeFlatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatCode =
s_JSCCombinedCode + 93431
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatIntoArrayCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeFlatIntoArrayCodeLength = 699;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayCode =
s_JSCCombinedCode + 93869
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatIntoArrayWithCallbackCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeFlatIntoArrayWithCallbackCodeLength = 731;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayWithCallbackCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayWithCallbackCode =
s_JSCCombinedCode + 94568
;

const JSC::ConstructAbility s_arrayPrototypeFlatMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeFlatMapCodeLength = 473;
static const JSC::Intrinsic s_arrayPrototypeFlatMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatMapCode =
s_JSCCombinedCode + 95299
;

const JSC::ConstructAbility s_stringPrototypeFontcolorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontcolorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFontcolorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeFontcolorCodeLength = 125;
static const JSC::Intrinsic s_stringPrototypeFontcolorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontcolorCode =
s_JSCCombinedCode + 95772
;

const JSC::ConstructAbility s_stringPrototypeFontsizeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontsizeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFontsizeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeFontsizeCodeLength = 121;
static const JSC::Intrinsic s_stringPrototypeFontsizeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontsizeCode =
s_JSCCombinedCode + 95897
;

const JSC::ConstructAbility s_arrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeForEachCodeLength = 475;
static const JSC::Intrinsic s_arrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeForEachCode =
s_JSCCombinedCode + 96018
;

const JSC::ConstructAbility s_mapPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_mapPrototypeForEachCodeLength = 539;
static const JSC::Intrinsic s_mapPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeForEachCode =
s_JSCCombinedCode + 96493
;

const JSC::ConstructAbility s_setPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_setPrototypeForEachCodeLength = 542;
static const JSC::Intrinsic s_setPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeForEachCode =
s_JSCCombinedCode + 97032
;

const JSC::ConstructAbility s_typedArrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeForEachCodeLength = 326;
static const JSC::Intrinsic s_typedArrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeForEachCode =
s_JSCCombinedCode + 97574
;

const JSC::ConstructAbility s_moduleLoaderForceFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderForceFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderForceFulfillPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderForceFulfillPromiseCodeLength = 237;
static const JSC::Intrinsic s_moduleLoaderForceFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderForceFulfillPromiseCode =
s_JSCCombinedCode + 97900
;

const JSC::ConstructAbility s_arrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorFromCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayConstructorFromCodeLength = 1950;
static const JSC::Intrinsic s_arrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorFromCode =
s_JSCCombinedCode + 98137
;

const JSC::ConstructAbility s_typedArrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayConstructorFromCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayConstructorFromCodeLength = 2306;
static const JSC::Intrinsic s_typedArrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorFromCode =
s_JSCCombinedCode + 100087
;

const JSC::ConstructAbility s_objectConstructorFromEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_objectConstructorFromEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_objectConstructorFromEntriesCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_objectConstructorFromEntriesCodeLength = 365;
static const JSC::Intrinsic s_objectConstructorFromEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_objectConstructorFromEntriesCode =
s_JSCCombinedCode + 102393
;

const JSC::ConstructAbility s_moduleLoaderFulfillFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderFulfillFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderFulfillFetchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderFulfillFetchCodeLength = 250;
static const JSC::Intrinsic s_moduleLoaderFulfillFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderFulfillFetchCode =
s_JSCCombinedCode + 102758
;

const JSC::ConstructAbility s_promiseOperationsFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsFulfillPromiseCodeLength = 600;
static const JSC::Intrinsic s_promiseOperationsFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillPromiseCode =
s_JSCCombinedCode + 103008
;

const JSC::ConstructAbility s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeLength = 389;
static const JSC::Intrinsic s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 103608
;

const JSC::ConstructAbility s_promiseOperationsFulfillWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsFulfillWithoutPromiseCodeLength = 139;
static const JSC::Intrinsic s_promiseOperationsFulfillWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillWithoutPromiseCode =
s_JSCCombinedCode + 103997
;

const JSC::ConstructAbility s_generatorPrototypeGeneratorResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeGeneratorResumeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeGeneratorResumeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_generatorPrototypeGeneratorResumeCodeLength = 930;
static const JSC::Intrinsic s_generatorPrototypeGeneratorResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeGeneratorResumeCode =
s_JSCCombinedCode + 104136
;

const JSC::ConstructAbility s_regExpPrototypeGetSubstitutionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeGetSubstitutionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeGetSubstitutionCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeGetSubstitutionCodeLength = 3659;
static const JSC::Intrinsic s_regExpPrototypeGetSubstitutionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeGetSubstitutionCode =
s_JSCCombinedCode + 105066
;

const JSC::ConstructAbility s_arrayPrototypeGroupCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeGroupCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeGroupCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeGroupCodeLength = 738;
static const JSC::Intrinsic s_arrayPrototypeGroupCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeGroupCode =
s_JSCCombinedCode + 108725
;

const JSC::ConstructAbility s_arrayPrototypeGroupToMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeGroupToMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeGroupToMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeGroupToMapCodeLength = 712;
static const JSC::Intrinsic s_arrayPrototypeGroupToMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeGroupToMapCode =
s_JSCCombinedCode + 109463
;

const JSC::ConstructAbility s_reflectObjectHasCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectHasCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectHasCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_reflectObjectHasCodeLength = 200;
static const JSC::Intrinsic s_reflectObjectHasCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectHasCode =
s_JSCCombinedCode + 110175
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeLength = 527;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCode =
s_JSCCombinedCode + 110375
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeLength = 1373;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCode =
s_JSCCombinedCode + 110902
;

const JSC::ConstructAbility s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeLength = 609;
static const JSC::Intrinsic s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeHasObservableSideEffectsForStringReplaceCode =
s_JSCCombinedCode + 112275
;

const JSC::ConstructAbility s_shadowRealmPrototypeImportValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeImportValueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeImportValueCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_shadowRealmPrototypeImportValueCodeLength = 758;
static const JSC::Intrinsic s_shadowRealmPrototypeImportValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeImportValueCode =
s_JSCCombinedCode + 112884
;

const JSC::ConstructAbility s_arrayPrototypeIncludesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeIncludesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeIncludesCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeIncludesCodeLength = 808;
static const JSC::Intrinsic s_arrayPrototypeIncludesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeIncludesCode =
s_JSCCombinedCode + 113642
;

const JSC::ConstructAbility s_webAssemblyInstantiateStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyInstantiateStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_webAssemblyInstantiateStreamingCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_webAssemblyInstantiateStreamingCodeLength = 224;
static const JSC::Intrinsic s_webAssemblyInstantiateStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyInstantiateStreamingCode =
s_JSCCombinedCode + 114450
;

const JSC::ConstructAbility s_internalPromiseConstructorInternalAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_internalPromiseConstructorInternalAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_internalPromiseConstructorInternalAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_internalPromiseConstructorInternalAllCodeLength = 1438;
static const JSC::Intrinsic s_internalPromiseConstructorInternalAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_internalPromiseConstructorInternalAllCode =
s_JSCCombinedCode + 114674
;

const JSC::ConstructAbility s_arrayConstructorIsArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorIsArrayCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorIsArrayCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayConstructorIsArrayCodeLength = 202;
static const JSC::Intrinsic s_arrayConstructorIsArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorIsArrayCode =
s_JSCCombinedCode + 116112
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsExecutionStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsExecutionStateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeIsExecutionStateCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeIsExecutionStateCodeLength = 402;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsExecutionStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsExecutionStateCode =
s_JSCCombinedCode + 116314
;

const JSC::ConstructAbility s_globalObjectIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalObjectIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalObjectIsFiniteCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_globalObjectIsFiniteCodeLength = 216;
static const JSC::Intrinsic s_globalObjectIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalObjectIsFiniteCode =
s_JSCCombinedCode + 116716
;

const JSC::ConstructAbility s_numberConstructorIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_numberConstructorIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_numberConstructorIsFiniteCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_numberConstructorIsFiniteCodeLength = 211;
static const JSC::Intrinsic s_numberConstructorIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_numberConstructorIsFiniteCode =
s_JSCCombinedCode + 116932
;

const JSC::ConstructAbility s_globalObjectIsNaNCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalObjectIsNaNCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalObjectIsNaNCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_globalObjectIsNaNCodeLength = 122;
static const JSC::Intrinsic s_globalObjectIsNaNCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalObjectIsNaNCode =
s_JSCCombinedCode + 117143
;

const JSC::ConstructAbility s_numberConstructorIsNaNCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_numberConstructorIsNaNCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_numberConstructorIsNaNCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_numberConstructorIsNaNCodeLength = 70;
static const JSC::Intrinsic s_numberConstructorIsNaNCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_numberConstructorIsNaNCode =
s_JSCCombinedCode + 117265
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeIsSuspendYieldStateCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_asyncGeneratorPrototypeIsSuspendYieldStateCodeLength = 327;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsSuspendYieldStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsSuspendYieldStateCode =
s_JSCCombinedCode + 117335
;

const JSC::ConstructAbility s_stringPrototypeItalicsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeItalicsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeItalicsCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeItalicsCodeLength = 107;
static const JSC::Intrinsic s_stringPrototypeItalicsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeItalicsCode =
s_JSCCombinedCode + 117662
;

const JSC::ConstructAbility s_moduleLoaderLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLinkCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderLinkCodeLength = 800;
static const JSC::Intrinsic s_moduleLoaderLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkCode =
s_JSCCombinedCode + 117769
;

const JSC::ConstructAbility s_stringPrototypeLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeLinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeLinkCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeLinkCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeLinkCode =
s_JSCCombinedCode + 118569
;

const JSC::ConstructAbility s_moduleLoaderLinkAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLinkAndEvaluateModuleCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderLinkAndEvaluateModuleCodeLength = 280;
static const JSC::Intrinsic s_moduleLoaderLinkAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkAndEvaluateModuleCode =
s_JSCCombinedCode + 118680
;

const JSC::ConstructAbility s_moduleLoaderLoadAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLoadAndEvaluateModuleCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderLoadAndEvaluateModuleCodeLength = 203;
static const JSC::Intrinsic s_moduleLoaderLoadAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadAndEvaluateModuleCode =
s_JSCCombinedCode + 118960
;

const JSC::ConstructAbility s_moduleLoaderLoadModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLoadModuleCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderLoadModuleCodeLength = 293;
static const JSC::Intrinsic s_moduleLoaderLoadModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadModuleCode =
s_JSCCombinedCode + 119163
;

const JSC::ConstructAbility s_arrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeMapCodeLength = 623;
static const JSC::Intrinsic s_arrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMapCode =
s_JSCCombinedCode + 119456
;

const JSC::ConstructAbility s_typedArrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeMapCodeLength = 843;
static const JSC::Intrinsic s_typedArrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeMapCode =
s_JSCCombinedCode + 120079
;

const JSC::ConstructAbility s_mapIteratorPrototypeMapIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeMapIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapIteratorPrototypeMapIteratorNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_mapIteratorPrototypeMapIteratorNextCodeLength = 505;
static const JSC::Intrinsic s_mapIteratorPrototypeMapIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeMapIteratorNextCode =
s_JSCCombinedCode + 120922
;

const JSC::ConstructAbility s_regExpPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeMatchCodeLength = 338;
static const JSC::Intrinsic s_regExpPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchCode =
s_JSCCombinedCode + 121427
;

const JSC::ConstructAbility s_stringPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeMatchCodeLength = 492;
static const JSC::Intrinsic s_stringPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchCode =
s_JSCCombinedCode + 121765
;

const JSC::ConstructAbility s_regExpPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeMatchAllCodeLength = 619;
static const JSC::Intrinsic s_regExpPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchAllCode =
s_JSCCombinedCode + 122257
;

const JSC::ConstructAbility s_stringPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeMatchAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeMatchAllCodeLength = 657;
static const JSC::Intrinsic s_stringPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchAllCode =
s_JSCCombinedCode + 122876
;

const JSC::ConstructAbility s_regExpPrototypeMatchSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeMatchSlowCodeLength = 812;
static const JSC::Intrinsic s_regExpPrototypeMatchSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchSlowCode =
s_JSCCombinedCode + 123533
;

const JSC::ConstructAbility s_arrayPrototypeMaxWithPositivesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMaxWithPositivesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMaxWithPositivesCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeMaxWithPositivesCodeLength = 69;
static const JSC::Intrinsic s_arrayPrototypeMaxWithPositivesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMaxWithPositivesCode =
s_JSCCombinedCode + 124345
;

const JSC::ConstructAbility s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeLength = 138;
static const JSC::Intrinsic s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCode =
s_JSCCombinedCode + 124414
;

const JSC::ConstructAbility s_moduleLoaderModuleEvaluationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderModuleEvaluationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderModuleEvaluationCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderModuleEvaluationCodeLength = 585;
static const JSC::Intrinsic s_moduleLoaderModuleEvaluationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderModuleEvaluationCode =
s_JSCCombinedCode + 124552
;

const JSC::ConstructAbility s_promiseOperationsNewHandledRejectedPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewHandledRejectedPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewHandledRejectedPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsNewHandledRejectedPromiseCodeLength = 304;
static const JSC::Intrinsic s_promiseOperationsNewHandledRejectedPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewHandledRejectedPromiseCode =
s_JSCCombinedCode + 125137
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilityCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilityCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewPromiseCapabilityCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsNewPromiseCapabilityCodeLength = 565;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilityCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilityCode =
s_JSCCombinedCode + 125441
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilitySlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilitySlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewPromiseCapabilitySlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsNewPromiseCapabilitySlowCodeLength = 879;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilitySlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilitySlowCode =
s_JSCCombinedCode + 126006
;

const JSC::ConstructAbility s_moduleLoaderNewRegistryEntryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderNewRegistryEntryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderNewRegistryEntryCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_moduleLoaderNewRegistryEntryCodeLength = 673;
static const JSC::Intrinsic s_moduleLoaderNewRegistryEntryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderNewRegistryEntryCode =
s_JSCCombinedCode + 126885
;

const JSC::ConstructAbility s_arrayIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayIteratorPrototypeNextCodeLength = 549;
static const JSC::Intrinsic s_arrayIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeNextCode =
s_JSCCombinedCode + 127558
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncFromSyncIteratorPrototypeNextCodeLength = 1061;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeNextCode =
s_JSCCombinedCode + 128107
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncGeneratorPrototypeNextCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeNextCode =
s_JSCCombinedCode + 129168
;

const JSC::ConstructAbility s_generatorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_generatorPrototypeNextCodeLength = 441;
static const JSC::Intrinsic s_generatorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeNextCode =
s_JSCCombinedCode + 129286
;

const JSC::ConstructAbility s_mapIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_mapIteratorPrototypeNextCodeLength = 384;
static const JSC::Intrinsic s_mapIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeNextCode =
s_JSCCombinedCode + 129727
;

const JSC::ConstructAbility s_regExpStringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpStringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpStringIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpStringIteratorPrototypeNextCodeLength = 1328;
static const JSC::Intrinsic s_regExpStringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpStringIteratorPrototypeNextCode =
s_JSCCombinedCode + 130111
;

const JSC::ConstructAbility s_setIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_setIteratorPrototypeNextCodeLength = 383;
static const JSC::Intrinsic s_setIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeNextCode =
s_JSCCombinedCode + 131439
;

const JSC::ConstructAbility s_stringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringIteratorPrototypeNextCodeLength = 1247;
static const JSC::Intrinsic s_stringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringIteratorPrototypeNextCode =
s_JSCCombinedCode + 131822
;

const JSC::ConstructAbility s_arrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayConstructorOfCodeLength = 307;
static const JSC::Intrinsic s_arrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorOfCode =
s_JSCCombinedCode + 133069
;

const JSC::ConstructAbility s_typedArrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayConstructorOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayConstructorOfCodeLength = 430;
static const JSC::Intrinsic s_typedArrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorOfCode =
s_JSCCombinedCode + 133376
;

const JSC::ConstructAbility s_stringPrototypePadEndCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadEndCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypePadEndCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypePadEndCodeLength = 953;
static const JSC::Intrinsic s_stringPrototypePadEndCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadEndCode =
s_JSCCombinedCode + 133806
;

const JSC::ConstructAbility s_stringPrototypePadStartCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadStartCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypePadStartCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypePadStartCodeLength = 955;
static const JSC::Intrinsic s_stringPrototypePadStartCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadStartCode =
s_JSCCombinedCode + 134759
;

const JSC::ConstructAbility s_iteratorHelpersPerformIterationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersPerformIterationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersPerformIterationCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_iteratorHelpersPerformIterationCodeLength = 785;
static const JSC::Intrinsic s_iteratorHelpersPerformIterationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersPerformIterationCode =
s_JSCCombinedCode + 135714
;

const JSC::ConstructAbility s_promiseOperationsPerformPromiseThenCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPerformPromiseThenCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPerformPromiseThenCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPerformPromiseThenCodeLength = 1149;
static const JSC::Intrinsic s_promiseOperationsPerformPromiseThenCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPerformPromiseThenCode =
s_JSCCombinedCode + 136499
;

const JSC::ConstructAbility s_promiseOperationsPromiseEmptyOnFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseEmptyOnFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseEmptyOnFulfilledCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseEmptyOnFulfilledCodeLength = 66;
static const JSC::Intrinsic s_promiseOperationsPromiseEmptyOnFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseEmptyOnFulfilledCode =
s_JSCCombinedCode + 137648
;

const JSC::ConstructAbility s_promiseOperationsPromiseEmptyOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseEmptyOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseEmptyOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseEmptyOnRejectedCodeLength = 65;
static const JSC::Intrinsic s_promiseOperationsPromiseEmptyOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseEmptyOnRejectedCode =
s_JSCCombinedCode + 137714
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseReactionJobCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseReactionJobCodeLength = 1131;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobCode =
s_JSCCombinedCode + 137779
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseReactionJobWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseReactionJobWithoutPromiseCodeLength = 122;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobWithoutPromiseCode =
s_JSCCombinedCode + 138910
;

const JSC::ConstructAbility s_promiseOperationsPromiseRejectSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseRejectSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseRejectSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseRejectSlowCodeLength = 259;
static const JSC::Intrinsic s_promiseOperationsPromiseRejectSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseRejectSlowCode =
s_JSCCombinedCode + 139032
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveCodeLength = 374;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveCode =
s_JSCCombinedCode + 139291
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveSlowCodeLength = 258;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveSlowCode =
s_JSCCombinedCode + 139665
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveThenableJobCodeLength = 271;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobCode =
s_JSCCombinedCode + 139923
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobFastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobFastCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveThenableJobFastCodeLength = 1206;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobFastCode =
s_JSCCombinedCode + 140194
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeLength = 420;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCode =
s_JSCCombinedCode + 141400
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeLength = 1282;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCode =
s_JSCCombinedCode + 141820
;

const JSC::ConstructAbility s_moduleLoaderProvideFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderProvideFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderProvideFetchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderProvideFetchCodeLength = 230;
static const JSC::Intrinsic s_moduleLoaderProvideFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderProvideFetchCode =
s_JSCCombinedCode + 143102
;

const JSC::ConstructAbility s_promiseOperationsPushNewPromiseReactionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPushNewPromiseReactionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPushNewPromiseReactionCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsPushNewPromiseReactionCodeLength = 901;
static const JSC::Intrinsic s_promiseOperationsPushNewPromiseReactionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPushNewPromiseReactionCode =
s_JSCCombinedCode + 143332
;

const JSC::ConstructAbility s_promiseConstructorRaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorRaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorRaceCodeLength = 670;
static const JSC::Intrinsic s_promiseConstructorRaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRaceCode =
s_JSCCombinedCode + 144233
;

const JSC::ConstructAbility s_stringConstructorRawCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringConstructorRawCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringConstructorRawCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringConstructorRawCodeLength = 860;
static const JSC::Intrinsic s_stringConstructorRawCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringConstructorRawCode =
s_JSCCombinedCode + 144903
;

const JSC::ConstructAbility s_arrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeReduceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeReduceCodeLength = 954;
static const JSC::Intrinsic s_arrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceCode =
s_JSCCombinedCode + 145763
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeReduceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeReduceCodeLength = 660;
static const JSC::Intrinsic s_typedArrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceCode =
s_JSCCombinedCode + 146717
;

const JSC::ConstructAbility s_arrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeReduceRightCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeReduceRightCodeLength = 969;
static const JSC::Intrinsic s_arrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceRightCode =
s_JSCCombinedCode + 147377
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeReduceRightCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeReduceRightCodeLength = 675;
static const JSC::Intrinsic s_typedArrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceRightCode =
s_JSCCombinedCode + 148346
;

const JSC::ConstructAbility s_regExpPrototypeRegExpExecCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpExecCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeRegExpExecCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_regExpPrototypeRegExpExecCodeLength = 426;
static const JSC::Intrinsic s_regExpPrototypeRegExpExecCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpExecCode =
s_JSCCombinedCode + 149021
;

const JSC::ConstructAbility s_promiseConstructorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorRejectCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorRejectCodeLength = 340;
static const JSC::Intrinsic s_promiseConstructorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRejectCode =
s_JSCCombinedCode + 149447
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsRejectPromiseCodeLength = 717;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseCode =
s_JSCCombinedCode + 149787
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeLength = 390;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 150504
;

const JSC::ConstructAbility s_promiseOperationsRejectWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsRejectWithoutPromiseCodeLength = 140;
static const JSC::Intrinsic s_promiseOperationsRejectWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectWithoutPromiseCode =
s_JSCCombinedCode + 150894
;

const JSC::ConstructAbility s_stringPrototypeRepeatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeRepeatCodeLength = 532;
static const JSC::Intrinsic s_stringPrototypeRepeatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCode =
s_JSCCombinedCode + 151034
;

const JSC::ConstructAbility s_stringPrototypeRepeatCharactersSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCharactersSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatCharactersSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_stringPrototypeRepeatCharactersSlowPathCodeLength = 543;
static const JSC::Intrinsic s_stringPrototypeRepeatCharactersSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCharactersSlowPathCode =
s_JSCCombinedCode + 151566
;

const JSC::ConstructAbility s_stringPrototypeRepeatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_stringPrototypeRepeatSlowPathCodeLength = 496;
static const JSC::Intrinsic s_stringPrototypeRepeatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatSlowPathCode =
s_JSCCombinedCode + 152109
;

const JSC::ConstructAbility s_regExpPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeReplaceCodeLength = 3232;
static const JSC::Intrinsic s_regExpPrototypeReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeReplaceCode =
s_JSCCombinedCode + 152605
;

const JSC::ConstructAbility s_stringPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeReplaceCodeLength = 693;
static const JSC::Intrinsic s_stringPrototypeReplaceCodeIntrinsic = JSC::StringPrototypeReplaceIntrinsic;
const char* const s_stringPrototypeReplaceCode =
s_JSCCombinedCode + 155837
;

const JSC::ConstructAbility s_stringPrototypeReplaceAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeReplaceAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeReplaceAllCodeLength = 907;
static const JSC::Intrinsic s_stringPrototypeReplaceAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeReplaceAllCode =
s_JSCCombinedCode + 156530
;

const JSC::ConstructAbility s_moduleLoaderRequestFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestFetchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderRequestFetchCodeLength = 779;
static const JSC::Intrinsic s_moduleLoaderRequestFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestFetchCode =
s_JSCCombinedCode + 157437
;

const JSC::ConstructAbility s_moduleLoaderRequestImportModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestImportModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestImportModuleCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderRequestImportModuleCodeLength = 283;
static const JSC::Intrinsic s_moduleLoaderRequestImportModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestImportModuleCode =
s_JSCCombinedCode + 158216
;

const JSC::ConstructAbility s_moduleLoaderRequestInstantiateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestInstantiateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestInstantiateCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderRequestInstantiateCodeLength = 1264;
static const JSC::Intrinsic s_moduleLoaderRequestInstantiateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestInstantiateCode =
s_JSCCombinedCode + 158499
;

const JSC::ConstructAbility s_moduleLoaderRequestSatisfyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestSatisfyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestSatisfyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_moduleLoaderRequestSatisfyCodeLength = 1299;
static const JSC::Intrinsic s_moduleLoaderRequestSatisfyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestSatisfyCode =
s_JSCCombinedCode + 159763
;

const JSC::ConstructAbility s_promiseConstructorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promiseConstructorResolveCodeLength = 162;
static const JSC::Intrinsic s_promiseConstructorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorResolveCode =
s_JSCCombinedCode + 161062
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolvePromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsResolvePromiseCodeLength = 782;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseCode =
s_JSCCombinedCode + 161224
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeLength = 389;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 162006
;

const JSC::ConstructAbility s_promiseOperationsResolveWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolveWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolveWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsResolveWithoutPromiseCodeLength = 813;
static const JSC::Intrinsic s_promiseOperationsResolveWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolveWithoutPromiseCode =
s_JSCCombinedCode + 162395
;

const JSC::ConstructAbility s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeLength = 386;
static const JSC::Intrinsic s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCode =
s_JSCCombinedCode + 163208
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncFromSyncIteratorPrototypeReturnCodeLength = 1598;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeReturnCode =
s_JSCCombinedCode + 163594
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncGeneratorPrototypeReturnCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeReturnCode =
s_JSCCombinedCode + 165192
;

const JSC::ConstructAbility s_generatorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_generatorPrototypeReturnCodeLength = 436;
static const JSC::Intrinsic s_generatorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeReturnCode =
s_JSCCombinedCode + 165310
;

const JSC::ConstructAbility s_regExpPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeSearchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeSearchCodeLength = 846;
static const JSC::Intrinsic s_regExpPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSearchCode =
s_JSCCombinedCode + 165746
;

const JSC::ConstructAbility s_stringPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSearchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeSearchCodeLength = 498;
static const JSC::Intrinsic s_stringPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSearchCode =
s_JSCCombinedCode + 166592
;

const JSC::ConstructAbility s_setIteratorPrototypeSetIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeSetIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setIteratorPrototypeSetIteratorNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_setIteratorPrototypeSetIteratorNextCodeLength = 394;
static const JSC::Intrinsic s_setIteratorPrototypeSetIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeSetIteratorNextCode =
s_JSCCombinedCode + 167090
;

const JSC::ConstructAbility s_moduleLoaderSetStateToMaxCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderSetStateToMaxCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderSetStateToMaxCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_moduleLoaderSetStateToMaxCodeLength = 124;
static const JSC::Intrinsic s_moduleLoaderSetStateToMaxCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderSetStateToMaxCode =
s_JSCCombinedCode + 167484
;

const JSC::ConstructAbility s_stringPrototypeSmallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSmallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSmallCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeSmallCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeSmallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSmallCode =
s_JSCCombinedCode + 167608
;

const JSC::ConstructAbility s_arrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSomeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeSomeCodeLength = 532;
static const JSC::Intrinsic s_arrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSomeCode =
s_JSCCombinedCode + 167717
;

const JSC::ConstructAbility s_typedArrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeSomeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeSomeCodeLength = 386;
static const JSC::Intrinsic s_typedArrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSomeCode =
s_JSCCombinedCode + 168249
;

const JSC::ConstructAbility s_arrayPrototypeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeSortCodeLength = 944;
static const JSC::Intrinsic s_arrayPrototypeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCode =
s_JSCCombinedCode + 168635
;

const JSC::ConstructAbility s_typedArrayPrototypeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeSortCodeLength = 606;
static const JSC::Intrinsic s_typedArrayPrototypeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSortCode =
s_JSCCombinedCode + 169579
;

const JSC::ConstructAbility s_arrayPrototypeSortBucketSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortBucketSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortBucketSortCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortBucketSortCodeLength = 1056;
static const JSC::Intrinsic s_arrayPrototypeSortBucketSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortBucketSortCode =
s_JSCCombinedCode + 170185
;

const JSC::ConstructAbility s_arrayPrototypeSortCommitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCommitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCommitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortCommitCodeLength = 647;
static const JSC::Intrinsic s_arrayPrototypeSortCommitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCommitCode =
s_JSCCombinedCode + 171241
;

const JSC::ConstructAbility s_arrayPrototypeSortCompactCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCompactCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCompactCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortCompactCodeLength = 577;
static const JSC::Intrinsic s_arrayPrototypeSortCompactCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCompactCode =
s_JSCCombinedCode + 171888
;

const JSC::ConstructAbility s_arrayPrototypeSortMergeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortMergeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortMergeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortMergeCodeLength = 850;
static const JSC::Intrinsic s_arrayPrototypeSortMergeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortMergeCode =
s_JSCCombinedCode + 172465
;

const JSC::ConstructAbility s_arrayPrototypeSortMergeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortMergeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortMergeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortMergeSortCodeLength = 476;
static const JSC::Intrinsic s_arrayPrototypeSortMergeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortMergeSortCode =
s_JSCCombinedCode + 173315
;

const JSC::ConstructAbility s_arrayPrototypeSortStringComparatorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortStringComparatorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortStringComparatorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_arrayPrototypeSortStringComparatorCodeLength = 185;
static const JSC::Intrinsic s_arrayPrototypeSortStringComparatorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortStringComparatorCode =
s_JSCCombinedCode + 173791
;

const JSC::ConstructAbility s_globalOperationsSpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsSpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalOperationsSpeciesConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_globalOperationsSpeciesConstructorCodeLength = 542;
static const JSC::Intrinsic s_globalOperationsSpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsSpeciesConstructorCode =
s_JSCCombinedCode + 173976
;

const JSC::ConstructAbility s_globalOperationsSpeciesGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsSpeciesGetterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalOperationsSpeciesGetterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_globalOperationsSpeciesGetterCodeLength = 53;
static const JSC::Intrinsic s_globalOperationsSpeciesGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsSpeciesGetterCode =
s_JSCCombinedCode + 174518
;

const JSC::ConstructAbility s_regExpPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeSplitCodeLength = 3224;
static const JSC::Intrinsic s_regExpPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSplitCode =
s_JSCCombinedCode + 174571
;

const JSC::ConstructAbility s_stringPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeSplitCodeLength = 449;
static const JSC::Intrinsic s_stringPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSplitCode =
s_JSCCombinedCode + 177795
;

const JSC::ConstructAbility s_stringPrototypeStrikeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStrikeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeStrikeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeStrikeCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeStrikeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStrikeCode =
s_JSCCombinedCode + 178244
;

const JSC::ConstructAbility s_stringPrototypeStringConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStringConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeStringConcatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_stringPrototypeStringConcatSlowPathCodeLength = 197;
static const JSC::Intrinsic s_stringPrototypeStringConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStringConcatSlowPathCode =
s_JSCCombinedCode + 178355
;

const JSC::ConstructAbility s_stringPrototypeSubCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSubCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSubCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeSubCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSubCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSubCode =
s_JSCCombinedCode + 178552
;

const JSC::ConstructAbility s_stringPrototypeSupCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSupCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSupCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_stringPrototypeSupCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSupCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSupCode =
s_JSCCombinedCode + 178657
;

const JSC::ConstructAbility s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCode =
s_JSCCombinedCode + 178762
;

const JSC::ConstructAbility s_functionPrototypeSymbolHasInstanceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeSymbolHasInstanceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeSymbolHasInstanceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_functionPrototypeSymbolHasInstanceCodeLength = 253;
static const JSC::Intrinsic s_functionPrototypeSymbolHasInstanceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeSymbolHasInstanceCode =
s_JSCCombinedCode + 178816
;

const JSC::ConstructAbility s_iteratorPrototypeSymbolIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorPrototypeSymbolIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorPrototypeSymbolIteratorGetterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_iteratorPrototypeSymbolIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_iteratorPrototypeSymbolIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorPrototypeSymbolIteratorGetterCode =
s_JSCCombinedCode + 179069
;

const JSC::ConstructAbility s_regExpPrototypeTestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeTestCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeTestCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_regExpPrototypeTestCodeLength = 560;
static const JSC::Intrinsic s_regExpPrototypeTestCodeIntrinsic = JSC::RegExpTestIntrinsic;
const char* const s_regExpPrototypeTestCode =
s_JSCCombinedCode + 179123
;

const JSC::ConstructAbility s_promisePrototypeThenCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeThenCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeThenCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_promisePrototypeThenCodeLength = 601;
static const JSC::Intrinsic s_promisePrototypeThenCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeThenCode =
s_JSCCombinedCode + 179683
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncFromSyncIteratorPrototypeThrowCodeLength = 1599;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeThrowCode =
s_JSCCombinedCode + 180284
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_asyncGeneratorPrototypeThrowCodeLength = 129;
static const JSC::Intrinsic s_asyncGeneratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeThrowCode =
s_JSCCombinedCode + 181883
;

const JSC::ConstructAbility s_generatorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_generatorPrototypeThrowCodeLength = 518;
static const JSC::Intrinsic s_generatorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeThrowCode =
s_JSCCombinedCode + 182012
;

const JSC::ConstructAbility s_datePrototypeToDateTimeOptionsAnyAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToDateTimeOptionsAnyAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToDateTimeOptionsAnyAllCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_datePrototypeToDateTimeOptionsAnyAllCodeLength = 1211;
static const JSC::Intrinsic s_datePrototypeToDateTimeOptionsAnyAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToDateTimeOptionsAnyAllCode =
s_JSCCombinedCode + 182530
;

const JSC::ConstructAbility s_datePrototypeToDateTimeOptionsDateDateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToDateTimeOptionsDateDateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToDateTimeOptionsDateDateCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_datePrototypeToDateTimeOptionsDateDateCodeLength = 948;
static const JSC::Intrinsic s_datePrototypeToDateTimeOptionsDateDateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToDateTimeOptionsDateDateCode =
s_JSCCombinedCode + 183741
;

const JSC::ConstructAbility s_datePrototypeToDateTimeOptionsTimeTimeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToDateTimeOptionsTimeTimeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToDateTimeOptionsTimeTimeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_datePrototypeToDateTimeOptionsTimeTimeCodeLength = 1015;
static const JSC::Intrinsic s_datePrototypeToDateTimeOptionsTimeTimeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToDateTimeOptionsTimeTimeCode =
s_JSCCombinedCode + 184689
;

const JSC::ConstructAbility s_globalOperationsToIntegerOrInfinityCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsToIntegerOrInfinityCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalOperationsToIntegerOrInfinityCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_globalOperationsToIntegerOrInfinityCodeLength = 185;
static const JSC::Intrinsic s_globalOperationsToIntegerOrInfinityCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsToIntegerOrInfinityCode =
s_JSCCombinedCode + 185704
;

const JSC::ConstructAbility s_globalOperationsToLengthCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsToLengthCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalOperationsToLengthCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_globalOperationsToLengthCodeLength = 187;
static const JSC::Intrinsic s_globalOperationsToLengthCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsToLengthCode =
s_JSCCombinedCode + 185889
;

const JSC::ConstructAbility s_datePrototypeToLocaleDateStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleDateStringCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToLocaleDateStringCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_datePrototypeToLocaleDateStringCodeLength = 296;
static const JSC::Intrinsic s_datePrototypeToLocaleDateStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleDateStringCode =
s_JSCCombinedCode + 186076
;

const JSC::ConstructAbility s_datePrototypeToLocaleStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleStringCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToLocaleStringCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_datePrototypeToLocaleStringCodeLength = 294;
static const JSC::Intrinsic s_datePrototypeToLocaleStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleStringCode =
s_JSCCombinedCode + 186372
;

const JSC::ConstructAbility s_typedArrayPrototypeToLocaleStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeToLocaleStringCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeToLocaleStringCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeToLocaleStringCodeLength = 345;
static const JSC::Intrinsic s_typedArrayPrototypeToLocaleStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeToLocaleStringCode =
s_JSCCombinedCode + 186666
;

const JSC::ConstructAbility s_datePrototypeToLocaleTimeStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleTimeStringCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_datePrototypeToLocaleTimeStringCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_datePrototypeToLocaleTimeStringCodeLength = 296;
static const JSC::Intrinsic s_datePrototypeToLocaleTimeStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleTimeStringCode =
s_JSCCombinedCode + 187011
;

const JSC::ConstructAbility s_arrayPrototypeToReversedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToReversedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToReversedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeToReversedCodeLength = 422;
static const JSC::Intrinsic s_arrayPrototypeToReversedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToReversedCode =
s_JSCCombinedCode + 187307
;

const JSC::ConstructAbility s_arrayPrototypeToSortedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToSortedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToSortedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeToSortedCodeLength = 611;
static const JSC::Intrinsic s_arrayPrototypeToSortedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToSortedCode =
s_JSCCombinedCode + 187729
;

const JSC::ConstructAbility s_typedArrayPrototypeToSortedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeToSortedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeToSortedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_typedArrayPrototypeToSortedCodeLength = 677;
static const JSC::Intrinsic s_typedArrayPrototypeToSortedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeToSortedCode =
s_JSCCombinedCode + 188340
;

const JSC::ConstructAbility s_arrayPrototypeToSplicedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToSplicedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToSplicedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeToSplicedCodeLength = 1642;
static const JSC::Intrinsic s_arrayPrototypeToSplicedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToSplicedCode =
s_JSCCombinedCode + 189017
;

const JSC::ConstructAbility s_promiseOperationsTriggerPromiseReactionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsTriggerPromiseReactionsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsTriggerPromiseReactionsCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_promiseOperationsTriggerPromiseReactionsCodeLength = 607;
static const JSC::Intrinsic s_promiseOperationsTriggerPromiseReactionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsTriggerPromiseReactionsCode =
s_JSCCombinedCode + 190659
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArrayMergeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArrayMergeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeTypedArrayMergeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_typedArrayPrototypeTypedArrayMergeCodeLength = 558;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArrayMergeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArrayMergeCode =
s_JSCCombinedCode + 191266
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArrayMergeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArrayMergeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeTypedArrayMergeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_typedArrayPrototypeTypedArrayMergeSortCodeLength = 618;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArrayMergeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArrayMergeSortCode =
s_JSCCombinedCode + 191824
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeTypedArraySpeciesConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_typedArrayPrototypeTypedArraySpeciesConstructorCodeLength = 478;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArraySpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArraySpeciesConstructorCode =
s_JSCCombinedCode + 192442
;

const JSC::ConstructAbility s_arrayPrototypeWithCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeWithCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeWithCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const int s_arrayPrototypeWithCodeLength = 797;
static const JSC::Intrinsic s_arrayPrototypeWithCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeWithCode =
s_JSCCombinedCode + 192920
;

const JSC::ConstructAbility s_shadowRealmPrototypeWrapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeWrapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeWrapCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_shadowRealmPrototypeWrapCodeLength = 336;
static const JSC::Intrinsic s_shadowRealmPrototypeWrapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeWrapCode =
s_JSCCombinedCode + 193717
;

const JSC::ConstructAbility s_iteratorHelpersWrappedIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersWrappedIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersWrappedIteratorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const int s_iteratorHelpersWrappedIteratorCodeLength = 144;
static const JSC::Intrinsic s_iteratorHelpersWrappedIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersWrappedIteratorCode =
s_JSCCombinedCode + 194053
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, overriddenName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    return vm.builtinExecutables()->codeName##Executable()->link(vm, nullptr, vm.builtinExecutables()->codeName##Source(), std::nullopt, s_##codeName##Intrinsic); }
JSC_FOREACH_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace JSC
