/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCSSStyleDeclaration.h"

#include "ActiveDOMObject.h"
#include "CustomElementReactionQueue.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "IDLTypes.h"
#include "JSCSSRule.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBase.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSDeprecatedCSSOMValue.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include "WebCoreOpaqueRoot.h"
#include <JavaScriptCore/ArrayPrototype.h>
#include <JavaScriptCore/BuiltinNames.h>
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/PropertyNameArray.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_item);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_setProperty);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_removeProperty);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit);
static JSC_DECLARE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclarationConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssText);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssText);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_length);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_parentRule);
static JSC_DECLARE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssFloat);
static JSC_DECLARE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssFloat);

class JSCSSStyleDeclarationPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCSSStyleDeclarationPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCSSStyleDeclarationPrototype* ptr = new (NotNull, JSC::allocateCell<JSCSSStyleDeclarationPrototype>(vm)) JSCSSStyleDeclarationPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCSSStyleDeclarationPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCSSStyleDeclarationPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSCSSStyleDeclarationPrototype, JSCSSStyleDeclarationPrototype::Base);

using JSCSSStyleDeclarationDOMConstructor = JSDOMConstructorNotConstructable<JSCSSStyleDeclaration>;

template<> const ClassInfo JSCSSStyleDeclarationDOMConstructor::s_info = { "CSSStyleDeclaration"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclarationDOMConstructor) };

template<> JSValue JSCSSStyleDeclarationDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCSSStyleDeclarationDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "CSSStyleDeclaration"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSCSSStyleDeclaration::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSCSSStyleDeclarationPrototypeTableValues[] =
{
    { "constructor"_s, static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclarationConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cssText"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_cssText), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_cssText) } },
    { "length"_s, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_length), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "parentRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_parentRule), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cssFloat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_cssFloat), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_cssFloat) } },
    { "AppleColorFilter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubCaptionSide"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubHyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextCombine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasisColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextEmphasisStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubTextTransform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubWordBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "EpubWritingMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlignSelf"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAlt"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationFillMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationIterationCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationName"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationPlayState"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAnimationTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitAppearance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackdropFilter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackfaceVisibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBackgroundSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderAfterWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBeforeWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBottomLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderBottomRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderEndWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderHorizontalSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderStartWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderTopLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderTopRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBorderVerticalSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxDecorationBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxFlex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxFlexGroup"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxLines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxOrdinalGroup"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxOrient"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxPack"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxReflect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxShadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitBoxSizing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitClipPath"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnAxis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnBreakInside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnFill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnProgression"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnRuleWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnSpan"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumnWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitColumns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitCursorVisibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFilter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexBasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexFlow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexGrow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexShrink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFlexWrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFontKerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitFontSmoothing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateCharacter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphenateLimitLines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitHyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitInitialLetter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitJustifyContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitJustifyItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineBoxContain"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineClamp"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineGrid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLineSnap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLocale"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMarginStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMask"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageOutset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageSlice"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageSource"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskBoxImageWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskComposite"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPositionX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskPositionY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaskSourceType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaxLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMaxLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMinLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitMinLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitNbspMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitOrder"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPaddingStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspective"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPerspectiveOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitPrintColorAdjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitRtlOrdering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitRubyPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeImageThreshold"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeMargin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitShapeOutside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTapHighlightColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextCombine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecoration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationLine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationSkip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextDecorationsInEffect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextEmphasisStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextFillColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextSecurity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStroke"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStrokeColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextStrokeWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextUnderlinePosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTextZoom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformOriginZ"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransformStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionProperty"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitTransitionTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserDrag"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserModify"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitUserSelect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "WebkitWritingMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "accentColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "additiveSymbols"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignSelf"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alignmentBaseline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "all"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "alt"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationComposition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationFillMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationIterationCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationName"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationPlayState"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "animationTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "appearance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "aspectRatio"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backfaceVisibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "background"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundAttachment"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundBlendMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPositionX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundPositionY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "backgroundSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "basePalette"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "baselineShift"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "blockSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "border"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockEndWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStartWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBlockWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderBottomWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderCollapse"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderEndEndRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderEndStartRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageOutset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageSlice"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageSource"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderImageWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineEndWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStartWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderInlineWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderLeftWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderRightWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStartEndRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStartStartRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderTopWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "borderWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "boxShadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "boxSizing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "breakInside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "bufferedRendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "captionSide"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "caretColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clear"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clipPath"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "clipRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorAdjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorInterpolation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorInterpolationFilters"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "colorScheme"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnFill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnRuleWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnSpan"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columnWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "columns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "contain"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containIntrinsicBlockSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containIntrinsicHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containIntrinsicInlineSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containIntrinsicSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containIntrinsicWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "container"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containerName"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "containerType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "counterIncrement"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "counterReset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cursor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cx"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "cy"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "display"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "dominantBaseline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "emptyCells"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fallback"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fillOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fillRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "filter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexBasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexFlow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexGrow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexShrink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "flexWrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "float"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "floodColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "floodOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "font"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontDisplay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontFamily"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontFeatureSettings"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontKerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontPalette"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontStretch"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontSynthesis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariant"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantAlternates"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantCaps"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantEastAsian"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantLigatures"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantNumeric"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontVariantPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "fontWeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "glyphOrientationHorizontal"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "glyphOrientationVertical"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "grid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridArea"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoColumns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoFlow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridAutoRows"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumn"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridColumnStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridRowStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplate"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateAreas"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateColumns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "gridTemplateRows"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "hangingPunctuation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "imageOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "imageRendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inlineSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inputSecurity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "inset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "insetInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "isolation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifyContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifyItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "justifySelf"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "kerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "letterSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lightingColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lineBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "lineHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyleImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStylePosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "listStyleType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "margin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marginTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "marker"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerMid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "markerStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mask"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskComposite"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maskType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mathStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxBlockSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxInlineSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "maxWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minBlockSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minInlineSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "minWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "mixBlendMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "negative"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "objectFit"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "objectPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetAnchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetDistance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetPath"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "offsetRotate"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "order"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "orphans"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineOffset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "outlineWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowAnchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowWrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overflowY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overrideColors"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehavior"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "overscrollBehaviorY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pad"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "padding"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paddingTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "page"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pageBreakInside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "paintOrder"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspective"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "perspectiveOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "placeSelf"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "pointerEvents"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "prefix"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "printColorAdjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "quotes"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "r"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "range"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "resize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rotate"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rowGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "rx"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "ry"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scale"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollBehavior"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMargin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollMarginTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPadding"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlock"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlockEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBlockStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInlineEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingInlineStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollPaddingTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMargin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginBottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginLeft"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginRight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapMarginTop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapStop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "scrollSnapType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeImageThreshold"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeMargin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeOutside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "shapeRendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "speakAs"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "src"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stopColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stopOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "stroke"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeDasharray"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeDashoffset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeLinecap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeLinejoin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeMiterlimit"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "strokeWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "suffix"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "supportedColorSchemes"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "symbols"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "system"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "tabSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "tableLayout"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textAlignLast"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textAnchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textCombineUpright"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecoration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationLine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationSkip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationSkipInk"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textDecorationThickness"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textEmphasisStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textIndent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textJustify"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textOverflow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textRendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textShadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textTransform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textUnderlineOffset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "textUnderlinePosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "touchAction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformBox"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformOriginZ"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transformStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionProperty"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "transitionTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "translate"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "unicodeBidi"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "unicodeRange"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "vectorEffect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "verticalAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "visibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "whiteSpace"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "widows"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "willChange"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "wordWrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "writingMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "zIndex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "zoom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute) } },
    { "webkitAlignContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlignItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlignSelf"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAlt"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationFillMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationIterationCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationName"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationPlayState"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAnimationTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitAppearance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackdropFilter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackfaceVisibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBackgroundSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderAfterWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBeforeWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBottomLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderBottomRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderEndWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderHorizontalSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderStartWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderTopLeftRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderTopRightRadius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBorderVerticalSpacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxDecorationBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxFlex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxFlexGroup"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxLines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxOrdinalGroup"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxOrient"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxPack"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxReflect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxShadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitBoxSizing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitClipPath"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnAxis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnBreakInside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnCount"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnFill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnGap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnProgression"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnRuleWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnSpan"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumnWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitColumns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitCursorVisibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFilter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexBasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexDirection"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexFlow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexGrow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexShrink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFlexWrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFontKerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitFontSmoothing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateCharacter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphenateLimitLines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitHyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitInitialLetter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitJustifyContent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitJustifyItems"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineAlign"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineBoxContain"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineClamp"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineGrid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLineSnap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLocale"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMarginStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMask"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageOutset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageSlice"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageSource"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskBoxImageWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskClip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskComposite"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskImage"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPositionX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskPositionY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskRepeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskSize"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaskSourceType"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaxLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMaxLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMinLogicalHeight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitMinLogicalWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitNbspMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitOpacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitOrder"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingAfter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingBefore"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingEnd"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPaddingStart"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspective"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPerspectiveOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitPrintColorAdjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitRtlOrdering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitRubyPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeImageThreshold"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeMargin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitShapeOutside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTapHighlightColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextCombine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecoration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationLine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationSkip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextDecorationsInEffect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisPosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextEmphasisStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextFillColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextSecurity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStroke"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStrokeColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextStrokeWidth"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextUnderlinePosition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTextZoom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOrigin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginX"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginY"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformOriginZ"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransformStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionDelay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionDuration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionProperty"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitTransitionTimingFunction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserDrag"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserModify"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitUserSelect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "webkitWritingMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute) } },
    { "-apple-color-filter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-caption-side"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-hyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-combine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-emphasis-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-orientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-text-transform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-word-break"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-epub-writing-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-items"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-align-self"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-alt"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-delay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-duration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-fill-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-iteration-count"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-name"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-play-state"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-animation-timing-function"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-appearance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-backdrop-filter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-backface-visibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-clip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-background-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-after-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-before-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-bottom-left-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-bottom-right-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-end-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-horizontal-spacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-start-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-top-left-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-top-right-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-border-vertical-spacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-align"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-decoration-break"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-flex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-flex-group"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-lines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-ordinal-group"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-orient"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-pack"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-reflect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-shadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-box-sizing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-clip-path"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-axis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-break-inside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-count"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-fill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-progression"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-rule-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-span"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-column-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-columns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-cursor-visibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-filter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-basis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-flow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-grow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-shrink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-flex-wrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-font-kerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-font-smoothing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-character"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphenate-limit-lines"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-hyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-initial-letter"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-justify-content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-justify-items"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-align"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-box-contain"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-break"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-clamp"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-grid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-line-snap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-locale"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-logical-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-logical-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-margin-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-outset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-repeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-slice"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-source"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-box-image-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-clip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-composite"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-position-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-repeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-mask-source-type"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-max-logical-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-max-logical-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-min-logical-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-min-logical-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-nbsp-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-order"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-padding-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-perspective-origin-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-print-color-adjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-rtl-ordering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-ruby-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-image-threshold"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-margin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-shape-outside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-tap-highlight-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-combine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-line"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-skip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decoration-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-decorations-in-effect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-emphasis-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-fill-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-orientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-security"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-stroke-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-underline-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-text-zoom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-origin-z"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transform-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-delay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-duration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-property"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-transition-timing-function"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-drag"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-modify"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-user-select"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "-webkit-writing-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "accent-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "additive-symbols"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-items"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "align-self"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "alignment-baseline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-composition"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-delay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-duration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-fill-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-iteration-count"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-name"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-play-state"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "animation-timing-function"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "aspect-ratio"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "backface-visibility"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-attachment"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-blend-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-clip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-position-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-repeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "background-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "base-palette"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "baseline-shift"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "block-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-end-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-start-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-block-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-left-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-right-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-bottom-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-collapse"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-end-end-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-end-start-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-outset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-repeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-slice"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-source"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-image-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-end-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-start-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-inline-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-left-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-right-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-spacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-start-end-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-start-start-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-left-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-right-radius"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-top-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "border-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "box-shadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "box-sizing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "break-inside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "buffered-rendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "caption-side"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "caret-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "clip-path"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "clip-rule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-adjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-interpolation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-interpolation-filters"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "color-scheme"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-count"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-fill"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-rule-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-span"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "column-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "contain-intrinsic-block-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "contain-intrinsic-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "contain-intrinsic-inline-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "contain-intrinsic-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "contain-intrinsic-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "container-name"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "container-type"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "counter-increment"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "counter-reset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "dominant-baseline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "empty-cells"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "fill-opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "fill-rule"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-basis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-direction"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-flow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-grow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-shrink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flex-wrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flood-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "flood-opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-display"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-family"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-feature-settings"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-kerning"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-palette"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-stretch"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-synthesis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-alternates"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-caps"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-east-asian"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-ligatures"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-numeric"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-variant-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "font-weight"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "glyph-orientation-horizontal"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "glyph-orientation-vertical"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-area"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-columns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-flow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-auto-rows"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-column-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-row-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-areas"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-columns"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "grid-template-rows"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "hanging-punctuation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "image-orientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "image-rendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inline-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "input-security"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "inset-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-items"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "justify-self"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "letter-spacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "lighting-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "line-break"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "line-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "list-style-type"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "margin-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-mid"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "marker-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-clip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-composite"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-image"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-repeat"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mask-type"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "math-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-block-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-inline-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "max-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-block-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-height"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-inline-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "min-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "mix-blend-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "object-fit"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "object-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-anchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-distance"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-path"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "offset-rotate"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-offset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "outline-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-anchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-wrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overflow-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "override-colors"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "overscroll-behavior-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "padding-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-after"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-before"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "page-break-inside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "paint-order"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "perspective-origin-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-content"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-items"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "place-self"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "pointer-events"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "print-color-adjust"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "row-gap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-behavior"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-margin-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-block-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline-end"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-inline-start"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-padding-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-align"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-bottom"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-left"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-right"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-margin-top"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-stop"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "scroll-snap-type"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-image-threshold"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-margin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-outside"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "shape-rendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "speak-as"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stop-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stop-opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-dasharray"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-dashoffset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-linecap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-linejoin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-miterlimit"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-opacity"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "stroke-width"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "supported-color-schemes"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "tab-size"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "table-layout"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-align"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-align-last"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-anchor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-combine-upright"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-line"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-skip"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-skip-ink"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-decoration-thickness"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-color"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-emphasis-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-indent"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-justify"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-orientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-overflow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-rendering"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-shadow"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-transform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-underline-offset"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "text-underline-position"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "touch-action"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-box"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-x"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-y"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-origin-z"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transform-style"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-delay"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-duration"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-property"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "transition-timing-function"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "unicode-bidi"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "unicode-range"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "vector-effect"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "vertical-align"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "white-space"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "will-change"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-break"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-spacing"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "word-wrap"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "writing-mode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "z-index"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute) } },
    { "epubCaptionSide"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubHyphens"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextCombine"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasis"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasisColor"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextEmphasisStyle"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextOrientation"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubTextTransform"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubWordBreak"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "epubWritingMode"_s, static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute) } },
    { "item"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_item), (intptr_t) (1) } },
    { "getPropertyValue"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue), (intptr_t) (1) } },
    { "getPropertyPriority"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority), (intptr_t) (1) } },
    { "setProperty"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_setProperty), (intptr_t) (2) } },
    { "removeProperty"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_removeProperty), (intptr_t) (1) } },
    { "getPropertyShorthand"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand), (intptr_t) (0) } },
    { "isPropertyImplicit"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit), (intptr_t) (0) } },
    { "getPropertyCSSValue"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue), (intptr_t) (1) } },
};

const ClassInfo JSCSSStyleDeclarationPrototype::s_info = { "CSSStyleDeclaration"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclarationPrototype) };

void JSCSSStyleDeclarationPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCSSStyleDeclaration::info(), JSCSSStyleDeclarationPrototypeTableValues, *this);
    bool hasDisabledRuntimeProperties = false;
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().colorFilterEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "AppleColorFilter"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().accentColorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "accentColor"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "additiveSymbols"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().webAnimationsCompositeOperationsEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "animationComposition"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().aspectRatioEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "aspectRatio"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainmentEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containIntrinsicBlockSize"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containIntrinsicHeight"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containIntrinsicInlineSize"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containIntrinsicSize"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containIntrinsicWidth"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containerName"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "containerType"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "fallback"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssInputSecurityEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "inputSecurity"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "negative"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offsetAnchor"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offsetDistance"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offsetPath"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offsetPosition"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offsetRotate"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssScrollAnchoringEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overflowAnchor"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscrollBehavior"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscrollBehaviorBlock"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscrollBehaviorInline"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscrollBehaviorX"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscrollBehaviorY"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "pad"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "prefix"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "range"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "rotate"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "scale"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().CSSOMViewSmoothScrollingEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "scrollBehavior"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "suffix"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "symbols"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "system"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssTextAlignLastEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "textAlignLast"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssTextJustifyEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "textJustify"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssIndividualTransformPropertiesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "translate"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().colorFilterEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "-apple-color-filter"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().accentColorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "accent-color"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssCounterStyleAtRulesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "additive-symbols"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().webAnimationsCompositeOperationsEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "animation-composition"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().aspectRatioEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "aspect-ratio"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain-intrinsic-block-size"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain-intrinsic-height"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain-intrinsic-inline-size"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain-intrinsic-size"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainIntrinsicSizeEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "contain-intrinsic-width"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "container-name"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssContainerQueriesEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "container-type"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssInputSecurityEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "input-security"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset-anchor"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset-distance"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset-path"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset-position"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssMotionPathEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "offset-rotate"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssScrollAnchoringEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overflow-anchor"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscroll-behavior"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscroll-behavior-block"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscroll-behavior-inline"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscroll-behavior-x"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().overscrollBehaviorEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "overscroll-behavior-y"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().CSSOMViewSmoothScrollingEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "scroll-behavior"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssTextAlignLastEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "text-align-last"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().cssTextJustifyEnabled) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "text-justify"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (hasDisabledRuntimeProperties && structure()->isDictionary())
        flattenDictionaryObject(vm);
    putDirect(vm, vm.propertyNames->iteratorSymbol, globalObject()->arrayPrototype()->getDirect(vm, vm.propertyNames->builtinNames().valuesPrivateName()), static_cast<unsigned>(JSC::PropertyAttribute::DontEnum));
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSCSSStyleDeclaration::s_info = { "CSSStyleDeclaration"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCSSStyleDeclaration) };

JSCSSStyleDeclaration::JSCSSStyleDeclaration(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CSSStyleDeclaration>&& impl)
    : JSDOMWrapper<CSSStyleDeclaration>(structure, globalObject, WTFMove(impl))
{
}

void JSCSSStyleDeclaration::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));

    static_assert(!std::is_base_of<ActiveDOMObject, CSSStyleDeclaration>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSCSSStyleDeclaration::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCSSStyleDeclarationPrototype::create(vm, &globalObject, JSCSSStyleDeclarationPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCSSStyleDeclaration::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCSSStyleDeclaration>(vm, globalObject);
}

JSValue JSCSSStyleDeclaration::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCSSStyleDeclarationDOMConstructor, DOMConstructorID::CSSStyleDeclaration>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCSSStyleDeclaration::destroy(JSC::JSCell* cell)
{
    JSCSSStyleDeclaration* thisObject = static_cast<JSCSSStyleDeclaration*>(cell);
    thisObject->JSCSSStyleDeclaration::~JSCSSStyleDeclaration();
}

bool JSCSSStyleDeclaration::getOwnPropertySlot(JSObject* object, JSGlobalObject* lexicalGlobalObject, PropertyName propertyName, PropertySlot& slot)
{
    auto throwScope = DECLARE_THROW_SCOPE(JSC::getVM(lexicalGlobalObject));
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (auto index = parseIndex(propertyName)) {
        if (index.value() < thisObject->wrapped().length()) {
            auto value = toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, thisObject->wrapped().item(index.value()));
            RETURN_IF_EXCEPTION(throwScope, false);
            slot.setValue(thisObject, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly), value);
            return true;
        }
    }
    return JSObject::getOwnPropertySlot(object, lexicalGlobalObject, propertyName, slot);
}

bool JSCSSStyleDeclaration::getOwnPropertySlotByIndex(JSObject* object, JSGlobalObject* lexicalGlobalObject, unsigned index, PropertySlot& slot)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (LIKELY(index <= MAX_ARRAY_INDEX)) {
        if (index < thisObject->wrapped().length()) {
            auto value = toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, thisObject->wrapped().item(index));
            RETURN_IF_EXCEPTION(throwScope, false);
            slot.setValue(thisObject, static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly), value);
            return true;
        }
    }
    return JSObject::getOwnPropertySlotByIndex(object, lexicalGlobalObject, index, slot);
}

void JSCSSStyleDeclaration::getOwnPropertyNames(JSObject* object, JSGlobalObject* lexicalGlobalObject, PropertyNameArray& propertyNames, DontEnumPropertiesMode mode)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(object);
    ASSERT_GC_OBJECT_INHERITS(object, info());
    for (unsigned i = 0, count = thisObject->wrapped().length(); i < count; ++i)
        propertyNames.add(Identifier::from(vm, i));
    JSObject::getOwnPropertyNames(object, lexicalGlobalObject, propertyNames, mode);
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclarationConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSCSSStyleDeclarationPrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSCSSStyleDeclaration::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForCamelCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForCamelCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForCamelCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForWebKitCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForWebKitCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForWebKitCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForDashedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForDashedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForDashedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForDashedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForDashedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForDashedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForDashedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForDashedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.propertyValueForEpubCasedIDLAttribute(propertyNameToAtomString(propertyName)))));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::getPassingPropertyName<jsCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value, PropertyName propertyName)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setPropertyValueForEpubCasedIDLAttribute(propertyNameToAtomString(propertyName), WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttribute, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::setPassingPropertyName<setJSCSSStyleDeclaration_propertyValueForEpubCasedIDLAttributeSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_cssTextGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUSVString>(lexicalGlobalObject, throwScope, impl.cssText())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssText, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_cssTextGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_cssTextSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUSVString>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setCssText(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssText, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::set<setJSCSSStyleDeclaration_cssTextSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_lengthGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.length())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_length, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_lengthGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_parentRuleGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLNullable<IDLInterface<CSSRule>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.parentRule())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_parentRule, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_parentRuleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsCSSStyleDeclaration_cssFloatGetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, throwScope, impl.cssFloat())));
}

JSC_DEFINE_CUSTOM_GETTER(jsCSSStyleDeclaration_cssFloat, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::get<jsCSSStyleDeclaration_cssFloatGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSCSSStyleDeclaration_cssFloatSetter(JSGlobalObject& lexicalGlobalObject, JSCSSStyleDeclaration& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    invokeFunctorPropagatingExceptionIfNecessary(lexicalGlobalObject, throwScope, [&] {
        return impl.setCssFloat(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSCSSStyleDeclaration_cssFloat, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSCSSStyleDeclaration>::set<setJSCSSStyleDeclaration_cssFloatSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_itemBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto index = convert<IDLUnsignedLong>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.item(WTFMove(index)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_item, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_itemBody>(*lexicalGlobalObject, *callFrame, "item");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyValueBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.getPropertyValue(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyValue, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyValueBody>(*lexicalGlobalObject, *callFrame, "getPropertyValue");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyPriorityBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.getPropertyPriority(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyPriority, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyPriorityBody>(*lexicalGlobalObject, *callFrame, "getPropertyPriority");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_setPropertyBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto value = convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->argument(2);
    auto priority = argument2.value().isUndefined() ? emptyString() : convert<IDLLegacyNullToEmptyStringAdaptor<IDLUSVString>>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUndefined>(*lexicalGlobalObject, throwScope, [&]() -> decltype(auto) { return impl.setProperty(WTFMove(property), WTFMove(value), WTFMove(priority)); })));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_setProperty, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_setPropertyBody>(*lexicalGlobalObject, *callFrame, "setProperty");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_removePropertyBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    CustomElementReactionStack customElementReactionStack(*lexicalGlobalObject);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto property = convert<IDLUSVString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLUSVString>(*lexicalGlobalObject, throwScope, impl.removeProperty(WTFMove(property)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_removeProperty, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_removePropertyBody>(*lexicalGlobalObject, *callFrame, "removeProperty");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthandBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto propertyName = argument0.value().isUndefined() ? String() : convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLNullable<IDLDOMString>>(*lexicalGlobalObject, throwScope, impl.getPropertyShorthand(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthand, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyShorthandBody>(*lexicalGlobalObject, *callFrame, "getPropertyShorthand");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicitBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto propertyName = argument0.value().isUndefined() ? String() : convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLBoolean>(*lexicalGlobalObject, throwScope, impl.isPropertyImplicit(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicit, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_isPropertyImplicitBody>(*lexicalGlobalObject, *callFrame, "isPropertyImplicit");
}

static inline JSC::EncodedJSValue jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValueBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSCSSStyleDeclaration>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto propertyName = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLNullable<IDLInterface<DeprecatedCSSOMValue>>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, impl.getPropertyCSSValue(WTFMove(propertyName)))));
}

JSC_DEFINE_HOST_FUNCTION(jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValue, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSCSSStyleDeclaration>::call<jsCSSStyleDeclarationPrototypeFunction_getPropertyCSSValueBody>(*lexicalGlobalObject, *callFrame, "getPropertyCSSValue");
}

JSC::GCClient::IsoSubspace* JSCSSStyleDeclaration::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSCSSStyleDeclaration, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForCSSStyleDeclaration.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForCSSStyleDeclaration = WTFMove(space); },
        [] (auto& spaces) { return spaces.m_subspaceForCSSStyleDeclaration.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForCSSStyleDeclaration = WTFMove(space); }
    );
}

template<typename Visitor>
void JSCSSStyleDeclaration::visitChildrenImpl(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

DEFINE_VISIT_CHILDREN(JSCSSStyleDeclaration);

template<typename Visitor>
void JSCSSStyleDeclaration::visitOutputConstraints(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitOutputConstraints(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

template void JSCSSStyleDeclaration::visitOutputConstraints(JSCell*, AbstractSlotVisitor&);
template void JSCSSStyleDeclaration::visitOutputConstraints(JSCell*, SlotVisitor&);
void JSCSSStyleDeclaration::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSCSSStyleDeclaration*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSCSSStyleDeclarationOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsCSSStyleDeclaration = jsCast<JSCSSStyleDeclaration*>(handle.slot()->asCell());
    auto& owner = jsCSSStyleDeclaration->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from jsCSSStyleDeclaration";
    return containsWebCoreOpaqueRoot(visitor, owner);
}

void JSCSSStyleDeclarationOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCSSStyleDeclaration = static_cast<JSCSSStyleDeclaration*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCSSStyleDeclaration->wrapped(), jsCSSStyleDeclaration);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<CSSStyleDeclaration>&& impl)
{
    return createWrapper<CSSStyleDeclaration>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, CSSStyleDeclaration& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

CSSStyleDeclaration* JSCSSStyleDeclaration::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSCSSStyleDeclaration*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}
